// JavaScript Document

//	=========================================
//	  No 022 ： a_2_P095_001.js
//	  p.95　例題2　アポロニウスの円</title>
//	=========================================

//	+------+
//	| 変数 |
//	+------+

// キャンバス、ステージ
var cc;
var cs;

// キャンバスの幅、高さ
var bW;
var bH;
var cW;
var cH;

// 中心位置
var centerX;
var centerY;

// Ｘ軸、Ｙ軸
var axisX;
var axisY;

// Ｘ軸、Ｙ軸、原点テキスト
var tx;
var ty;
var t0;

// 軸線
var base;

// 方眼
var grid;

// 刻み幅
var stepSize;

// １目盛りのピクセル数
var span;

// １周期のピクセル
var baseCycle;

// グラフ共通の右下の歯車ボタンで使用する設定データ
var configArray;

// 軌跡を制御する場合
var recCont;
var recData;

// アニメーション制御用スライダー
var slider;
var animeFlag;

// ドラッグ関連
var prevX;
var prevY;
var dFlag;

// 既定値関連
var defMin;
var defMax;
var defNum;

// 図形用
var shp;						// 線、破線、円など
var SHAPE_DOT_1		=	0;		// 点１
var SHAPE_DOT_2		=	1;		// 点２
var SHAPE_DOT_C		=	2;		// 円の中心
var SHAPE_DOT_P		=	3;		// 点Ｐ
var SHAPE_CIRCLE	=	4;		// 円
var SHAPE_LINE_1	=	5;		// 線１
var SHAPE_LINE_2	=	6;		// 線２
var SHAPE_LINE_3	=	7;		// 線２
var SHAPE_MAX		=	8;		// 図形の数

// キャンバスに表示するテキスト
var txt;
var TEXT_A			=	0;		// 点Ａ
var TEXT_B			=	1;		// 点Ｂ
var TEXT_C			=	2;		// 円の中心
var TEXT_R			=	3;		// 円
var TEXT_P			=	4;		// 点Ｂ
var TEXT_MAX		=	5;		// テキストの数

// 値保存用
var p1x;						// 点１Ｘ
var p1y;						// 点１Ｙ
var p2x;						// 点２Ｘ
var p2y;						// 点２Ｙ
var px;							// 点ＰＸ
var py;							// 点ＰＹ
var cx;							// 円の中心Ｘ
var cy;							// 円の中心Ｙ
var cr;							// 円の半径
var apNum;						// 点ＡＰの長さ
var bpNum;						// 点ＢＰの長さ
var theta;						// 点Ｐの可動範囲
var dspForm;					// 式表示のオンオフ


//	+----------------+
//	| ロード時の処理 |
//	+----------------+
function loadContentHandler()
{
	try
	{
		// ----------
		// 初期値設定
		// ----------
		
		// １周期のピクセル
		baseCycle = 300;
		
		// 軸の1目盛当たりのピクセル数
		span = 30;
		
		// 刻み幅
		stepSize = 1;
		
		// キャンバスサイズ設定
		bW = pageWidth-52;
		bH = pageHeight;
		cW = bW * 3;
		cH = bH * 3;
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		document.getElementById("graphCanvas").style.left = (-bW + 120) + "px";
		document.getElementById("graphCanvas").style.top = (-bH) + "px";
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		document.getElementById("graphCanvas").style.position = "absolute";
		
		// 中心位置
		centerX = cW/2;
		centerY = cH/2;
		
		// 値の上限、下限、既定値
		defMin = -12;
		defMax = 12;
		defNum = -6;
		
		// ドラッグ関連
		dFlag = true;
		animeFlag = false;
		
		// 状態の記録エリア
		recData = [];
		
		p1x = -6;
		p1y = 0;
		p2x = 2;
		p2y = 0;
		px  = 0
		py  = 0;
		cx  = 0
		cy  = 0;
		cr  = 0;
		apNum = 3;
		bpNum = 1;
		theta = Math.PI / 2;
		dspForm = false;
		
		// ------------
		// 画面関連設定
		// ------------
		document.getElementById("balloonBottom").style.display = "none";
		
		// アニメーションスライダを吹き出しで使用する場合
		slider = new AnimeBalloon( defMin, defMax, defNum, 250, 40, false, stepSize, changeAnimeGraph, captureData, resetCapture );
		
		// ステージの作成
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		// 背景の作成
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		cs.addChild(bg);
		
		// 方眼の作成
		grid = new createjs.Shape();
		cs.addChild(grid);
		
		// 軸と矢印の作成
		base = new createjs.Shape();
		cs.addChild(base);
		axisX = new createjs.Shape();
		cs.addChild(axisX);
		axisY = new createjs.Shape();
		cs.addChild(axisY);
		
		// Ｘ軸、Ｙ軸、原点のテキスト作成
		tx = new createjs.Text("x", "italic 20px Times New Roman", "#000000");
		cs.addChild(tx);
		ty = new createjs.Text("y", "italic 20px Times New Roman", "#000000");
		cs.addChild(ty);
		t0 = new createjs.Text("O", "20px Times New Roman", "#000000");
		cs.addChild(t0);
		
		// 状態記録のコンテナ作成
		recCont = new createjs.Container();
		cs.addChild(recCont);
		
		// キャンパスに表示する図形
		shp = [];
		var nameTbl = [ "dot1", "dot2", "dotC", "dotP", "circle", "line1", "line2", "line3" ];
		for ( var i=0; i<SHAPE_MAX; i++ )	{
			shp[i] = new createjs.Shape();
			shp[i].name = nameTbl[i];
			cs.addChild(shp[i]);
		}
		
		// キャンバスに表示するテキスト
		txt = [];
		for ( var i=0; i<TEXT_MAX; i++ )	{
			txt[i] = new createjs.Text("", "18px Times New Roman", "#000000");
			txt[i].textAlign = "left";
			cs.addChild(txt[i]);
		}
		
		$(".lineText").focus(function(){$(this).blur();});
		
		// 入力欄の設定
		document.getElementById("x1Num").style.textAlign = "center";
		document.getElementById("x1Num").style.width = "40px";
		document.getElementById("x1Num").style.display = "inline-block";
		document.getElementById("x2Num").style.textAlign = "center";
		document.getElementById("x2Num").style.width = "40px";
		document.getElementById("x2Num").style.display = "inline-block";
		document.getElementById("pxNum").style.textAlign = "center";
		document.getElementById("pxNum").style.width = "40px";
		document.getElementById("pxNum").style.display = "inline-block";
		document.getElementById("pyNum").style.textAlign = "center";
		document.getElementById("pyNum").style.width = "40px";
		document.getElementById("pyNum").style.display = "inline-block";
		document.getElementById("apNum").style.textAlign = "center";
		document.getElementById("apNum").style.width = "40px";
		document.getElementById("apNum").style.display = "inline-block";
		document.getElementById("bpNum").style.textAlign = "center";
		document.getElementById("bpNum").style.width = "40px";
		document.getElementById("bpNum").style.display = "inline-block";
		
		// 設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [null, null];
		configArray[2] = [null, null];
		setGraphConfig();
		
		// チェックボックス
		document.getElementById("check0").checked = true;
		document.getElementById("check1").checked = true;
		document.getElementById("check2").checked = false;
		document.getElementById("check3").checked = false;
		
		//-------------
		// リスナー定義
		//-------------
		// リセット
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		// 刻み幅
//		document.getElementById("stepText").addEventListener("click", openMenuBalloonHandler);
		// チェックボックス
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		// 式の表示
		document.getElementById('menuNext').addEventListener('click', changeFormulaHandler);
		// ドットのドラッグ
		shp[SHAPE_DOT_1].addEventListener("mousedown", dotDragStart);
		shp[SHAPE_DOT_2].addEventListener("mousedown", dotDragStart);
		shp[SHAPE_DOT_P].addEventListener("mousedown", dotDragStart);
		// キャンバスのドラッグ
		cs.addEventListener("mousedown", canvasDragStart);
		// オプションボタン（数式の設定画面）
//		document.getElementById('optionBtn0').addEventListener('click', openOptionHandler);
//		document.getElementById('optionClose').addEventListener('click', closeOptionHandler);
		// 値の設定
		document.getElementById("upBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn2").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn4").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn5").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn2").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn4").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn5").addEventListener("click", changeDataHandler);
		
		//-------------
		// 画面初期表示
		//-------------
		
		// 使用しないバルーン・非表示
		document.getElementById("selectBalloon_menu").style.display = "none";			// 刻み幅
		document.getElementById("selectBalloon_config").style.display = "none";			// 設定画面
		//document.getElementById("animeBalloon").style.display = "none";					// アニメ
		
		// スライダー設定
		document.getElementById("loopBtn").src = "./img/autoIcon.png";;
		document.getElementById('speedConfig').src = "./img/s1.png";
		slider.min = defMin;
		slider.max = defMax;
		slider.prev = defNum;
		slider.loopFlag = true;
		slider.loopMode = 1;
		slider.speedIndex = 2;
		slider.changeSliderLine();
		slider.changeSliderPoint();
		slider.changeSliderControl();
		
		// 刻み幅
//		document.getElementById("stepText").innerHTML = stepSize;
		
		// 軸表示
		drawBaseLine();
		changeAxisPositionHandler();
		
		// 計算処理
		calcData();
		
		// 式の表示
		drawFormula();
		
		// 図形の表示
		drawShape();
		
		// テキストの表示
		drawText();
		
		// オプションメニュー画面
		setModal('optionBlock');
		setModal('spanChange');
		setMenuMode(0, 320);
		$("#controlBlock").css("overflow-x", "hidden");		// 横スクロールバーは非表示
		
		// ステージ更新
		cs.update();
		
		// バージョンチェック
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

//	+------------------------------------+
//	| 以下は必要なので削除してはいけない |
//	+------------------------------------+

//	+--------------------------+
//	| アニメ制御画面のオープン |
//	+--------------------------+
function setAnimeBalloonPosition()
{
	slider.openAnimeBalloon("pointP");
	$("#animeBalloon").css("margin-left", 25);
	$("#animeTriangle").css("margin-left", 6);
}

//	+----------------+
//	| アニメーション |
//	+----------------+
function changeAnimeGraph()
{
	theta = Math.PI * ( ( slider.prev - slider.min ) / ( slider.max - slider.min ) ) * 2;
	calcData();
	drawFormula();
	drawShape();
	drawText();
	slider.ss.update();
	cs.update();
}

//	+--------------+
//	|  |
//	+--------------+
function changeFormulaPositionHandler(num)
{
	return;
}
//	+--------------+
//	|  |
//	+--------------+
function captureData()
{
	try
	{
		createcaptureData([px,py]);
		cs.update();
	}
	catch(e)
	{
		alert("captureData:" + e.toString());
	}
}

//	+--------------+
//	|  |
//	+--------------+
function createcaptureData(n)
{
	try
	{
		var s = new createjs.Shape();
		s.name = "s" + recData.length;
		cs.addChild(s);
		
		drawDot( s, n[0], n[1], "orange", 0.25 );
		cs.update();
		
		recCont.addChild(s);
		recData.push(n);
	}
	catch(e)
	{
		alert("createcaptureData:" + e.toString());
	}
		
}

//	+--------------+
//	|  |
//	+--------------+
function resetCapture()
{
	try
	{
		var leng = recData.length;
		//オブジェクトを削除
		recCont.removeAllChildren();
		//データの削除
		recData = [];
		cs.update();
	}
	catch(e)
	{
		alert("resetCapture:" + e.toString());
	}
}
//	+----------------------------------------+
//	| ここまでは必要なので削除してはいけない |
//	+----------------------------------------+

//	+--------------------+
//	| ベースラインの描画 |
//	+--------------------+
function drawBaseLine()
{
	try
	{
		// 軸と矢印の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		// Ｘ軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		// Ｙ軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		// Ｘ軸の矢印
		axisX.graphics.beginFill("#000000");
		axisX.graphics.moveTo(-20, 0);
		axisX.graphics.lineTo(-20, -4);
		axisX.graphics.lineTo(-2, 0);
		axisX.graphics.lineTo(-20, 4);
		axisX.graphics.lineTo(-20, 0);
		axisX.graphics.endFill();
		// Ｙ軸の矢印
		axisY.graphics.beginFill("#000000");
		axisY.graphics.moveTo(0, 20);
		axisY.graphics.lineTo(-4, 20);
		axisY.graphics.lineTo(0, 2);
		axisY.graphics.lineTo(4, 20);
		axisY.graphics.lineTo(0, 20);
		axisY.graphics.endFill();
		axisY.graphics.endStroke();
		// Ｘ軸、Ｙ軸の位置
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		numX = -numX.substring(0, numX.length-2);
		numY = -numY.substring(0, numY.length-2);
		axisX.x = numX + bW;
		axisX.y = centerY;
		axisY.x = centerX;
		axisY.y = numY;
		// Ｘ軸、Ｙ軸、原点のテキスト
		tx.x = numX + bW -tx.getBounds().width-5;
		tx.y = cH/2+5;
		ty.x = cW/2+10;
		ty.y = numY + 2;
		t0.x = cW/2+5;
		t0.y = cH/2+5;
	}
	catch(e)
	{
		alert("drawBase:"+e.toString());
	}
}

//	+----------+
//	| 軸の表示 |
//	+----------+
function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(axisX.x-2, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, axisY.y+2);
		base.graphics.lineTo(cW/2, cH);
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}

//	+------------+
//	| 図形の表示 |
//	+------------+
function drawShape()
{
	try
	{
		for ( var i=0; i<SHAPE_MAX; i++ )		{	shp[i].graphics.clear();	}
		// 各ドット
		if ( document.getElementById("check0").checked )	{		drawDot(shp[SHAPE_DOT_1],p1x,p1y,"gray",0.5);		}
		if ( document.getElementById("check1").checked )	{		drawDot(shp[SHAPE_DOT_2],p2x,p2y,"gray",0.5);		}
		
		if ( document.getElementById("check3").checked )
		{
			drawRing( shp[SHAPE_CIRCLE], cx, cy, cr, "blue" );
			drawDot( shp[SHAPE_DOT_C], cx, cy, "gray", 0.5 );
		}
		
		if ( document.getElementById("check2").checked )
		{
			drawDot(shp[SHAPE_DOT_P],px,py,"red",0.5);
			drawLine_3( shp[SHAPE_LINE_2], p1x, p1y, px, py, "gray", 1.0 );
			drawLine_3( shp[SHAPE_LINE_2], px, py, p2x, p2y, "gray", 1.0 );
			for ( var i=1; i<apNum; i++ )
			{ 
				drawEqlenLine( shp[SHAPE_LINE_3], p1x, p1y, px, py, i * 1 / apNum, "gray", 1.0 );
			}
			for ( var i=1; i<bpNum; i++ )
			{ 
				drawEqlenLine( shp[SHAPE_LINE_3], px, py, p2x, p2y, i * 1 / bpNum, "gray", 1.0 );
			}
		}
		if ( document.getElementById("check3").checked )
		{
			//drawLine_1( shp[SHAPE_LINE_1], pa, bp, pc, "blue" );
		}
	}
	catch(e)
	{
		alert("drawShape:" + e.toString());
	}
}

//	+--------------+
//	| ドットの表示 |
//	+--------------+
function drawDot(dot,x,y,color,alpha)
{
	try
	{
		var col = "rgba(0,0,0," + alpha + ")";
		switch( color )
		{
			case "gray":
				col = "rgba(32,32,32," + alpha + ")";
				break;
			case "blue":
				col = "rgba(0,165,199," + alpha + ")";
				break;
			case "red":
				col = "rgba(255,0,0," + alpha + ")";
				break;
			case "orange":
				col = "rgba(255,127,0," + alpha + ")";
				break;
		}
		
		var x = centerX + x * span;
		var y = centerY - y * span;
		dot.graphics.setStrokeStyle(1);
		dot.graphics.beginStroke("rgba(255, 255, 255, 0.02)");
		dot.graphics.beginFill(col);
		dot.graphics.drawCircle(x, y, 5);
		dot.graphics.beginFill("rgba(255, 255, 255, 0.02)");
		dot.graphics.drawCircle(x, y, 15);
		dot.graphics.endFill();
		dot.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawDot:" + e.toString());
	}
}

//	+----------------+
//	| テキストの表示 |
//	+----------------+
function drawText()
{
	try
	{
		// 円２の座標表示
		for ( var i=0; i<TEXT_MAX; i++ )	{	txt[i].visible = false;	}
		
		if ( document.getElementById("check3").checked )
		{
			txt[TEXT_C].text = Math.round(cx*100)/100;
			txt[TEXT_C].x = centerX + cx * span - 4;
			txt[TEXT_C].y = centerY - cy * span - 22;
			txt[TEXT_C].visible = true;
			txt[TEXT_R].text = Math.round((cx+cr)*100)/100;
			txt[TEXT_R].x = centerX + (cx+cr) * span - 4;
			txt[TEXT_R].y = centerY - cy * span - 22;
			txt[TEXT_R].visible = true;
		}
		
		if ( document.getElementById("check0").checked )
		{
			txt[TEXT_A].text = "A(" + Math.round(p1x*100)/100 + "," + Math.round(p1y*100)/100 + ")"
			txt[TEXT_A].x = centerX + p1x * span - 4;
			txt[TEXT_A].y = centerY - p1y * span + 4;
			txt[TEXT_A].visible = true;
		}
		if ( document.getElementById("check1").checked )
		{
			txt[TEXT_B].text = "B(" + Math.round(p2x*100)/100 + "," + Math.round(p2y*100)/100 + ")"
			txt[TEXT_B].x = centerX + p2x * span - 4;
			txt[TEXT_B].y = centerY - p2y * span + 4;
			txt[TEXT_B].visible = true;
		}
		if ( document.getElementById("check2").checked )
		{
			txt[TEXT_P].text = "P(" + Math.round(px*100)/100 + "," + Math.round(py*100)/100 + ")"
			txt[TEXT_P].x = centerX + px * span + 6;
			txt[TEXT_P].y = centerY - py * span - 10;
			txt[TEXT_P].visible = true;
		}
	}
	catch(e)
	{
		alert("drawText:" + e.toString());
	}
}

//	+--------------+
//	| 式や値の表示 |
//	+--------------+
function drawFormula()
{
	try
	{
		document.getElementById("outApNum").innerHTML = apNum;
		document.getElementById("outBpNum").innerHTML = bpNum;
		document.getElementById("apNum").innerHTML = apNum;
		document.getElementById("bpNum").innerHTML = bpNum;
		
		document.getElementById("x1Num").innerHTML = p1x;
		document.getElementById("x2Num").innerHTML = p2x;
		document.getElementById("pointP").style.display = "none";
		document.getElementById("form0").style.display = "none";
		if ( dspForm )
		{
			var str = "\\small{";
			var r = Math.round( cr * cr * 100 ) / 100;
			var x = Math.round( cx * 100 ) / 100;
			if(x > 0){ str += "(x-" + x + ")^2"; }
			else if(x < 0){ str += "(x" + x + ")^2"; }
			else{ str += "x^2"; }
			str += "+y^2=" + r + "}";
			changeMathJax("form0", str, false);
			document.getElementById("form0").style.display = "";
		}
	}
	catch(e)
	{
		alert("drawText:" + e.toString());
	}
}

//	+----------+
//	| 円の表示 |
//	+----------+
function drawRing(circle, x, y, r, col)
{
	try
	{
		circle.graphics.setStrokeStyle(1);
		// 色
		switch( col )
		{
			case "blue":
				circle.graphics.beginStroke("#007AC5");
				break;
			case "red":
				circle.graphics.beginStroke("#FF0000");
				break;
			default:
				circle.graphics.beginStroke("#000000");
				break;
		}
		circle.graphics.drawCircle( centerX + x * span, centerY - y * span, Math.abs(r) * span );
		circle.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawRing:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示１ |
//	+--------------+
function drawLine_1(line, a, b, c, col)
{
	try
	{
		// 傾き(軸の方向注意)
		var pA = a / b;
		
		// 切片(軸の方向注意)
		var pB = c / b;
		
		line.graphics.setStrokeStyle(1);
		
		// 色
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("#007AC5");
				break;
			case "red":
				line.graphics.beginStroke("#FF0000");
				break;
			default:
				line.graphics.beginStroke("#000000");
				break;
		}
		
		// 縦の線
		if ( b == 0 )
		{
			line.graphics.moveTo(0, -cH);
			line.graphics.lineTo(0, cH);
			line.x = cW/2 + (-c/a) * span;
			line.y = cH/2;
		}
		// 横の線
		else if ( a == 0 )
		{
			line.graphics.moveTo(-cW, 0);
			line.graphics.lineTo(cW, 0);
			line.x = cW/2;
			line.y = cH/2 + pB * span;
		}
		else
		{
			line.graphics.moveTo(-cH/ pA, -cH);
			line.graphics.lineTo(cH/ pA, cH);
			line.x = cW/2;
			line.y = cH/2 + pB  * span;
			
		}
		
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLineHandler:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示２ |
//	+--------------+
function drawLine_2(line,xx1,yy1,xx2,yy2,col,alpha)
{
	try
	{
		var k = ( x2 - x1 ) / ( y2 - y1 ) * 2000;
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 165, 199, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span + k, centerY - yy1 * span + 2000);
		line.graphics.lineTo( centerX + xx2 * span - k, centerY - yy2 * span - 2000);
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLineHandler:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示３ |
//	+--------------+
function drawLine_3(line,xx1,yy1,xx2,yy2,col,alpha)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 165, 199, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span, centerY - yy1 * span);
		line.graphics.lineTo( centerX + xx2 * span, centerY - yy2 * span);
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLineHandler:" + e.toString());
	}
}

//	+--------------+
//	| 等長線の表示 |
//	+--------------+
function drawEqlenLine(line,x1,y1,x2,y2,pos,col,alpha)
{
	try
	{
		x1 = centerX + x1 * span;
		y1 = centerY - y1 * span;
		x2 = centerX + x2 * span;
		y2 = centerY - y2 * span;
		var t =  Math.atan2( ( x2 - x1 ) , ( y2 - y1 ) );
		var xx = Math.cos(t) * 5;
		var yy = Math.sin(t) * 5;
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 165, 199, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		var bX1 = x2 + ( x1 - x2 ) * pos;
		var bY1 = y2 + ( y1 - y2 ) * pos;
		line.graphics.moveTo( bX1 + xx, bY1 - yy );
		line.graphics.lineTo( bX1 - xx, bY1 + yy );
	}
	catch(e)
	{
		alert("drawEqlenLine:" + e.toString());
	}
}

//	+----------+
//	| 座標表示 |
//	+----------+
function drawPosText(text1,text2)
{
	var x = text1.text;
	var y = text2.text;
	text1.x = centerX + x * span - 4;
	if ( y >= 0 )
	{
		text1.y = centerY;
	}
	else
	{
		text1.y = centerY - 20;
	}
	if ( x >= 0 )
	{
		text2.textAlign = "right";
		text2.x = centerX - 4;
	}
	else
	{
		text2.textAlign = "left";
		text2.x = centerX + 4;
	}
	text2.y = centerY - y * span - 10;
}

//	+----------+
//	| 計算処理 |
//	+----------+
function calcData()
{
	try
	{
		var l = ( p1x * bpNum + p2x * apNum ) / ( apNum + bpNum );
		var r = ( p2x * apNum - p1x * bpNum ) / ( apNum - bpNum );
		if ( apNum >= bpNum )
		{
			cr = Math.round( ( r - l ) / 2 * 100 ) / 100;
			cx = l + cr;
		}
		else
		{
			cr = Math.round( ( l - r ) / 2 * 100 ) / 100;
			cx = l - cr;
		}
		cy = 0;
		px = cx + Math.cos( theta ) * cr;
		py = cy + Math.sin( theta ) * cr;
		px = Math.round( px * 100 ) / 100;
		py = Math.round( py * 100 ) / 100;
	}
	catch(e)
	{
		alert("calcData:" + e.toString());
	}
}
function calcLine(x1,y1,x2,y2)
{
	
	var a = ( x2-x1 ) / ( y2-y1 );
	var b = 1;
	var c = y2;
	return [ {a:a,b:b,c:c} ];
}

// 円と直線の交点
function cli(a,b,c,x1,y1,r)
{
	var l = a*a+b*b;
	var k = a*x1+b*y1+c;
	var d = l*r*r-k*k;
	if(d>0){
		var ds = Math.sqrt(d);
		var apl = a/l;
		var bpl = b/l;
		var xc = x1-apl*k;
		var yc = y1-bpl*k;
		var xd = bpl*ds;
		var yd = apl*ds;
		return [
			{x:xc-xd,y:yc+yd},
			{x:xc+xd,y:yc-yd}
		];
	}else if(d==0){
		return [{x:x1-a*k/l,y:y1-b*k/l}];
	}else{
		return [];
	}
}
// 円と円の交点
function cci(x1,y1,r1,x2,y2,r2)
{
	var a = x1-x2;
	var b = y1-y2;
	return cli(a,b,0.5*((r1-r2)*(r1+r2)-a*(x1+x2)-b*(y1+y2)),x1,y1,r1);
}

// 円の半径
function calcRad(x,y,l,m,n)
{
	var xx = x + l / 2;
	var yy = y + m / 2;
	var rad = ( l * l + m * m ) / 4 + n;
	var r = Math.sqrt( rad );
	return	[ {x:xx,y:yy,rad:rad,r:r} ];
}

//	+----------+
//	| 値の入力 |
//	+----------+
function changeDataHandler(e)
{
	try
	{
		switch( e.currentTarget.id )
		{
			case "upBtn0":
				p1x += stepSize;
				document.getElementById("x1Num").innerHTML = Math.round( p1x * 100 ) / 100;
				break;
			case "downBtn0":
				p1x -= stepSize;
				document.getElementById("x1Num").innerHTML = Math.round( p1x * 100 ) / 100;
				break;
			case "upBtn2":
				p2x += stepSize;
				document.getElementById("x2Num").innerHTML = Math.round( p2x * 100 ) / 100;
				break;
			case "downBtn2":
				p2x -= stepSize;
				document.getElementById("x2Num").innerHTML = Math.round( p2x * 100 ) / 100;
				break;
			case "upBtn4":
				apNum += stepSize;
				if(apNum == bpNum){ apNum += stepSize; } 
				document.getElementById("apNum").innerHTML = Math.round( px * 100 ) / 100;
				break;
			case "downBtn4":
				var temp = apNum;
				temp -= stepSize;
				if(temp == bpNum){ temp -= stepSize; }
				if(temp <= 0){ temp = apNum; }
				apNum = temp;
				document.getElementById("apNum").innerHTML = Math.round( px * 100 ) / 100;
				break;
			case "upBtn5":
				bpNum += stepSize;
				if(bpNum == apNum){ bpNum += stepSize; }
				document.getElementById("bpNum").innerHTML = Math.round( py * 100 ) / 100;
				break;
			case "downBtn5":
				var temp = bpNum;
				temp -= stepSize;
				if(temp == apNum){ temp -= stepSize; }
				if(temp <= 0){ temp = bpNum; }
				bpNum = temp;
				document.getElementById("bpNum").innerHTML = Math.round( py * 100 ) / 100;
				break;
		}
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

//	+--------------------------------+
//	| 軌跡の式表示ボタンのオン・オフ |
//	+--------------------------------+
function changeFormulaHandler(e)
{
	if ( dspForm )
	{
		dspForm = false;
	}
	else
	{
		dspForm = true;
	}
	drawFormula();
	cs.update();
}


//	+------------------------------+
//	| チェックボックスのオン・オフ |
//	+------------------------------+
function changeCheckHandler(e)
{
	try
	{
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

//	+----------------------+
//	| 刻み幅の設定画面表示 |
//	+----------------------+
function openMenuBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		if ( e.currentTarget.id == "stepText" )
		{
			inner = [0.1, 0.2, 0.5, 1, 2, 5, 10];
			data = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		}
		openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeStepSize);
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}
//	+--------------+
//	| 刻み幅の変更 |
//	+--------------+
function changeStepSize(id, num)
{
	try
	{
		stepSize = num;
		var n;
		
		// 設定した刻み幅の倍数に変更
		n   = Math.round(p1x/num) * num;
		p1x = Math.round(n * 100)/100;
		n   = Math.round(p1y/num) * num;
		p1y = Math.round(n * 100)/100;
		n   = Math.round(p2x/num) * num;
		p2x = Math.round(n * 100)/100;
		n   = Math.round(p2y/num) * num;
		p2y = Math.round(n * 100)/100;
		n   = Math.round(px/num) * num;
		px  = Math.round(n * 100)/100;
		n   = Math.round(py/num) * num;
		py  = Math.round(n * 100)/100;
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeStepSize:" + e.toString());
	}
}

//	+------------------+
//	| 点のドラッグ開始 |
//	+------------------+
function dotDragStart(e)
{
	try
	{
		if ( dFlag )
		{
			if ( e.currentTarget.name != "dot1" && e.currentTarget.name != "dot2" && e.currentTarget.name != "dotP" )	RETURN;
			
			dFlag = false;
			prevX = e.stageX;
			prevY = e.stageY;
			
			e.currentTarget.addEventListener("pressmove", dotDragMove);
			e.currentTarget.addEventListener("pressup", dotDragStop);
			e.currentTarget.addEventListener("mouseup", dotDragStop);
			e.currentTarget.addEventListener("mouseout", dotDragStop);
		}
	}
	catch(e)
	{
		alert("dotDragStart:" + e.toString());
	}
}

//	+--------------+
//	| 点のドラッグ |
//	+--------------+
function dotDragMove(e)
{
	try
	{
		var x = e.stageX - prevX;
		var y = e.stageY - prevY;
		var size = 0.01;
		
		if ( Math.abs( x ) > 1 || Math.abs( y ) > 1 )
		{
			prevX = e.stageX;
			prevY = e.stageY;
			var numX = ( e.stageX - centerX ) / span;
			var numY = ( e.stageY - centerY ) / span;
			numX = Math.round( numX / size ) * size;
			numY = Math.round( numY / size ) * size;
			numX = Math.round( numX * 10 ) / 10;
			numY = Math.round( numY * 10 ) / 10;
			if ( e.currentTarget.name == "dot1" )
			{
				p1x = numX;
				p1y = 0;
			}
			if ( e.currentTarget.name == "dot2" )
			{
				p2x = numX;
				p2y = 0;
			}
			if ( e.currentTarget.name == "dotP" )
			{
				numX = ( e.stageX - centerX ) / span - cx;
				numY = ( e.stageY - centerY ) / span - cy;
				numX = Math.round( numX * 10 ) / 10;
				numY = Math.round( numY * 10 ) / 10;
				theta = Math.atan2( -numY, numX );
				var t = Math.PI / slider.max;
				var n = Math.round( theta / t );
				slider.prev = n + slider.min;
				if ( slider.prev < slider.min )	{
					slider.prev = n + slider.max;
				}
				if ( slider.prev == slider.min )	{
					if ( numY > 0 )		{	slider.prev = n + slider.max;	}
				}
				slider.changeSliderPoint();
				slider.ss.update();
			}
		}
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("dotDragMove:" + e.toString());
	}
}

//	+------------------+
//	| 点のドラッグ終了 |
//	+------------------+
function dotDragStop(e)
{
	try
	{
		dFlag = true;
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		
		e.currentTarget.removeEventListener("pressmove", dotDragMove);
		e.currentTarget.removeEventListener("pressup", dotDragMove);
		e.currentTarget.removeEventListener("mouseup", dotDragMove);
		e.currentTarget.removeEventListener("mouseout", dotDragMove);
	}
	catch(e)
	{
		alert("dotDragStop:" + e.toString());
	}
}

//	+------------------+
//	| 円のドラッグ開始 |
//	+------------------+
/*----------------------------------------------------------------------------------------------------------------------
function lineDragStart(e)
{
	try
	{
		if ( dFlag )
		{
			dFlag = false;
			prevX = e.stageX;
			prevY = e.stageY;
			
			
			
			cs.update();
			e.currentTarget.addEventListener("pressmove", lineDragMove);
			e.currentTarget.addEventListener("pressup",lineDragStop);
			e.currentTarget.addEventListener("mouseup", lineDragStop);
			e.currentTarget.addEventListener("mouseout", lineDragStop);
		}
	}
	catch(e)
	{
		alert("lineDragStart:" + e.toString());
	}
}
*/

//	+--------------+
//	| 円のドラッグ |
//	+--------------+
/*----------------------------------------------------------------------------------------------------------------------
function lineDragMove(e)
{
	try
	{
		var x = e.stageX - prevX;
		var y = e.stageY - prevY;
		var size = 0.01;
		
		
		
	}
	catch(e)
	{
		alert("lineDragMove:" + e.toString());
	}
}
*/
//	+------------------+
//	| 円のドラッグ終了 |
//	+------------------+
/*----------------------------------------------------------------------------------------------------------------------
function lineDragStop(e)
{
	try
	{
	
	
	
		e.currentTarget.removeEventListener("pressmove", dotDragMove);
		e.currentTarget.removeEventListener("pressup", dotDragMove);
		e.currentTarget.removeEventListener("mouseup", dotDragMove);
		e.currentTarget.removeEventListener("mouseout", dotDragMove);
	}
	catch(e)
	{
		alert("lineDragStop:" + e.toString());
	}
}
*/

//	+--------------------------+
//	| キャンバスのドラッグ開始 |
//	+--------------------------+
function canvasDragStart(e)
{
	if(dFlag)
	{
		prevX = e.stageX;
		prevY = e.stageY;
		
		if(ictMode)
		{
			$(window).on("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchend', dragStop);
		}
		else
		{
			document.addEventListener('mouseup', dragStop);
		}
		
		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

//	+----------------------+
//	| キャンバスのドラッグ |
//	+----------------------+
function canvasDragMove(e)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		//座標の変化量
		var sX;
		var sY;
		
		if(cScale >= 1)
		{
			sX = e.stageX - prevX;
			sY = e.stageY - prevY;
		}
		else
		{
			sX = (e.stageX - prevX) * cScale;
			sY = (e.stageY - prevY) * cScale;
		}
		
		//移動限界
		var limitX = cW * 1/3 - cW * cScale;
		var limitY = cH * 1/3 - cH * cScale;
		
		//Xの差分移動
		if(p.left + sX >= 0)
		{
			document.getElementById("graphCanvas").style.left = "0px";
			
			prevX = e.stageX;
		}
		else if(p.left + sX <= limitX)
		{
			document.getElementById("graphCanvas").style.left = limitX + "px";
			
			prevX = e.stageX;
		}
		else
		{
			document.getElementById("graphCanvas").style.left = (p.left + sX) + "px";
		}
		
		//Yの差分移動
		if(p.top + sY >= 0)
		{
			document.getElementById("graphCanvas").style.top = "0px";
			
			prevY = e.stageY;
		}
		else if(p.top + sY <= limitY)
		{
			document.getElementById("graphCanvas").style.top = limitY + "px";
			
			prevY = e.stageY;
		}
		else
		{
			document.getElementById("graphCanvas").style.top = (p.top + sY) + "px";
		}
		
		changeAxisPositionHandler();
		changeGraphScale(configArray[1][0], configArray[1][1]);
		cs.update();
	}
	catch(e)
	{
		alert("canvasDragMove:" + e.toString());
	}
	
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function canvasDragStop(e)
{
	e.currentTarget.removeEventListener("pressmove", canvasDragMove);
	e.currentTarget.removeEventListener("pressup", canvasDragStop);
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function dragStop(e)
{
	try
	{
		if(ictMode)
		{
			$(window).off("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchend', dragStop);
		}
		else
		{
			document.removeEventListener('mouseup', dragStop);
		}
	}
	catch(e)
	{
		alert(e.toString());	
	}
}

//	+----------------+
//	| グラフ目盛変更 |
//	+----------------+
function changePointText(c, str)
{
	try
	{
		//削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		//弧度法
		if(str.indexOf("π") != -1)
		{
			//頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				var t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
				
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str, "16px Times New Roman", "#000000");
					c.addChild(t0_5);
				}
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("changePointText:" + str + "-" + e.toString());
	}
}

//	+----------------------------+
//	| オプション画面のスクロール |
//	+----------------------------+
function closeInnerBalloonHandler(e)
{
	try
	{
		// 刻み幅入力画面が開かれていたら閉じる
		if ( document.getElementById("selectBalloon_menu").style.display != "none" )
		{
			closeSelectBalloon();
		}
	}
	catch(e)
	{
		alert("closeInnerBalloonHandler:" + e.toString());
	}
}

//	+--------------+
//	| スケール変更 |
//	+--------------+
function changeGraphScale(sX, sY)
{
	try
	{
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		
		//y軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の目盛
		if(sX != null)
		{
			var spanX = span * sX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
		}
		
		
		//y軸の目盛
		if(sY != null)
		{
			spanY = span * sY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
		}
	}
	catch(e)
	{
		alert("changeGraphScale:" + e.toString());
	}
}

//	+--------------+
//	| グリッド変更 |
//	+--------------+
function changeGraphGrid(gX, gY)
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の線
		if(gX != null)
		{
			var spanX = span * gX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
		}
		
		
		//y軸の線
		if(gY != null)
		{
			spanY = span * gY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
		}
	}
	catch(e)
	{
		alert('changeGraphGrid:' + e.toString());
	}
}

// +----------+
// | 状態保存 |
// +----------+
function saveContent()
{
	try
	{
		var array = [];
		
		// 刻み値
		array[0] = stepSize;
		
		//設定吹き出し
		array[1] = configArray.slice();
		
		// 変数
		array[2] = [ { x:p1x, y:p1y }, { x:p2x, y:p2y }, { x:px, y:py }, { x:cx, y:cy, r:cr }, { ab:apNum, bp:bpNum, theta:theta, dspForm:dspForm } ];
		
		// 画面項目
		var chk0 = document.getElementById("check0").checked;
		var chk1 = document.getElementById("check1").checked;
		var chk2 = document.getElementById("check2").checked;
		var chk3 = document.getElementById("check3").checked;
		array[3] = [ { chk0:chk0, chk1:chk1, chk2:chk2, chk3:chk3 } ];
		
		// 軌跡
		array[4] = recData.slice();
		
		// スライダー
		array[5] = [slider.min, slider.max, slider.prev];
		array[6] = slider.loopFlag;
		array[7] = slider.loopMode;
		array[8] = slider.speedIndex;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

// +----------+
// | 状態読込 |
// +----------+
function loadContent(array)
{
	try
	{
		// 刻み値
		stepSize = array[0];
		//document.getElementById("stepText").innerHTML = stepSize;
		
		//設定吹き出し
		configArray = array[1].slice();
		
		// 変数
		p1x = array[2][0].x;
		p1y = array[2][0].y;
		
		p2x = array[2][1].x;
		p2y = array[2][1].y;
		
		px  = array[2][2].x;
		py  = array[2][2].y;
		
		cx  = array[2][3].x;
		cy  = array[2][3].y;
		cr  = array[2][3].r;
		
		apNum = array[2][4].ab;
		bpNum = array[2][4].bp;
		theta = array[2][4].theta;
		dspForm = array[2][4].dspForm;
		
		// 画面項目
		document.getElementById("check0").checked = array[3][0].chk0;
		document.getElementById("check1").checked = array[3][0].chk1;
		document.getElementById("check2").checked = array[3][0].chk2;
		document.getElementById("check3").checked = array[3][0].chk3;
		
		//軌跡の設定
		resetCapture();
		for(var i=0; i<array[4].length; i++)
		{
			createcaptureData(array[4][i]);
		}
		
		// スライダー
		slider.min = array[5][0];
		slider.max = array[5][1];
		slider.prev = array[5][2];
		slider.loopFlag = array[6];
		slider.loopMode = array[7];
		switch(slider.loopMode)
		{
			case 0:
				document.getElementById("loopBtn").src = "./img/loopIcon.png";
				break;
			case 1:
				document.getElementById("loopBtn").src = "./img/autoIcon.png";
				break;
			case 2:
				document.getElementById("loopBtn").src = "./img/normalIcon.png";
				break;
		}
		slider.speedIndex = array[8];
		document.getElementById("speedConfig").src = "./img/s" +slider.speedArray[array[8]]+ ".png";
		document.getElementById("tMin").innerHTML = slider.min;
		document.getElementById("tMax").innerHTML = slider.max;
		slider.changeSliderLine();
		slider.changeSliderPoint();
		slider.changeSliderControl();
		
		changeGraphScale(null, null);
		changeGraphGrid(null, null);
		
		// 画面表示
		document.getElementById("x1Num").innerHTML = p1x;
		document.getElementById("x2Num").innerHTML = p2x;
		document.getElementById("pxNum").innerHTML = px;
		document.getElementById("pyNum").innerHTML = py;
		
		drawFormula();
		drawShape();
		drawText();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

// +----------+
// | リセット |
// +----------+
function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			// 刻み値
			stepSize = 1;
			
			//設定吹き出し
			configArray = [];
			configArray[0] = [-30, 360, -10, 10];
			configArray[1] = [null, null];
			configArray[2] = [null, null];
			
			// 値の上限、下限、既定値
			defMin = -12;
			defMax = 12;
			defNum = -6;
			
			p1x = -6;
			p1y = 0;
			p2x = 2;
			p2y = 0;
			px  = 0
			py  = 0;
			cx  = 0
			cy  = 0;
			cr  = 0;
			apNum = 3;
			bpNum = 1;
			theta = Math.PI / 2;
			dspForm = false;
		
			// ドラッグ関連
			dFlag = true;
			animeFlag = false;
			
			// 状態の記録エリア
			recData = [];
			
			// チェックボックス
			document.getElementById("check0").checked = true;
			document.getElementById("check1").checked = true;
			document.getElementById("check2").checked = false;
			document.getElementById("check3").checked = false;
			
			// ドラッグ関連
			dFlag = true;
			
			// 初期表示に戻す
			changeGraphScale(null, null);
			changeGraphGrid(null, null);
			
			// スライダー
			document.getElementById("loopBtn").src = "./img/autoIcon.png";
			document.getElementById('speedConfig').src = "./img/s1.png";
			slider.min = defMin;
			slider.max = defMax;
			slider.prev = defNum;
			slider.loopFlag = false;
			slider.loopMode = 1;
			slider.speedIndex = 2;
			document.getElementById("tMin").innerHTML = slider.min;
			document.getElementById("tMax").innerHTML = slider.max;
			slider.changeSliderLine();
			slider.changeSliderPoint();
			slider.changeSliderControl();
			
			document.getElementById("x1Num").innerHTML = p1x;
			document.getElementById("x2Num").innerHTML = p2x;
			document.getElementById("pxNum").innerHTML = px;
			document.getElementById("pyNum").innerHTML = py;
			
			// 軌跡も削除
			resetCapture();
			
			// 刻み幅
//			document.getElementById("stepText").innerHTML = stepSize;
			
			// 軸表示
			drawBaseLine();
			changeAxisPositionHandler();
			
			// 計算処理
			calcData();
			
			// 式の表示
			drawFormula();
			
			// 図形の表示
			drawShape();
			
			// テキストの表示
			drawText();
		
			// オプションメニュー画面
			setModal('optionBlock');
			setModal('spanChange');
			setMenuMode(0, 320);
			$("#controlBlock").css("overflow-x", "hidden");		// 横スクロールバーは非表示
			
			// ステージ更新
			cs.update();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
S