// JavaScript Document
var cc;
var cs;

var bW;
var bH;

var gW;
var gH;
var gSpan;
var rSpan;

//刻み幅
var stepSize;

//グラフ共通の右下の歯車ボタンで使用する設定データ
var configArray;

//軌跡を制御する場合
var recCont1;
var recCont2;

var recData;

//アニメーション制御を使用する場合
var slider;

var baseCycle;

var optionFlag;

var browse;

var defNum;
var minNum;
var maxNum;

//円のグラフ
var graph0;

//sinのグラフ
var graph1;

//cosのグラフ
var graph2;

var dragPoint0;
var dragPoint1;
var targetPoint;

var pointArray;

var dotLine;

var rotFlag;

var rotShape;

var tTheta;

var line1;
var line2;

var sinPoint;
var cosPoint;

var radArray;

var c0;
var c1;

var graphX;
var graphY;

var sinText;
var sinLine;
var sinTheta;

var cosText;
var cosLine;
var cosTheta;

var tx0;
var tx1;
var tx2;
var ty0;
var ty1;
var ty2;

function loadContentHandler()
{
	try
	{
		//1周期のドット
		baseCycle = 260;
		
		//軸の1目盛当たりのドット数
		span = baseCycle/Math.PI;
		
		stepSize = 1;
		
		defNum = 0;
		minNum = 0;
		maxNum = 450;
		
		bW = pageWidth-52;
		bH = pageHeight+100;
		
		gW = (span + 30) * 3.5;
		gH = (span +30) * 2;
		gSpan = 160;
		rSpan = 160;
		
		cc = document.getElementById("graphCanvas0");
		cs = new createjs.Stage(cc);
		cc.width = bW;
		cc.height = bH;
		createjs.Touch.enable(cs);
		
		pointArray = [];
		
		rotFlag = false;
		
		c0 = "#007AC5";
		c1 = "#007700";
		
		graph0 = createCommonGraphContainer((span+30) * 2, gH, 0, true);
		graph0.name = "graph0";
		graph1 = createCommonGraphContainer(gW, gH, gSpan, false);
		graph1.name = "graph1";
		graph2 = createCommonGraphContainer(gW, gH, gSpan, false);
		graph2.name = "graph2";
		
		recCont1 = new createjs.Container();
		graph1.addChild(recCont1);
		recCont1.alpha = 0.5;
		recCont1.visible = false;
		
		recCont2 = new createjs.Container();
		graph2.addChild(recCont2);
		recCont2.alpha = 0.5;
		recCont2.visible = false;
		
		cs.addChild(graph0);
		cs.addChild(graph1);
		cs.addChild(graph2);
		
		graphX = 240;
		graphY = 120;
		
		graph0.x = graphX;
		graph0.y = graphY;
		
		graph1.x = graphX + rSpan;
		graph1.y = graphY;
		
		graph2.x = graphX;
		graph2.y = graphY + rSpan;
		graph2.rotation = 90;
		
		rotShape = new createjs.Shape();
		graph0.addChild(rotShape);
		
		var circle = new createjs.Shape();
		circle.graphics.setStrokeStyle(1);
		circle.graphics.beginStroke("#000000");
		circle.graphics.drawCircle(0, 0, span);
		graph0.addChild(circle);
		
		dragPoint0 = new createjs.Shape();
		dragPoint0.graphics.beginStroke(0);
		dragPoint0.graphics.beginStroke("rgba(255, 255, 255, 0)");
		dragPoint0.graphics.beginFill("rgba(255, 0, 0, 0.5)");
		dragPoint0.graphics.drawCircle(0, 0, 10);
		dragPoint0.graphics.beginFill("rgba(255, 255, 255, 0.01)");
		dragPoint0.graphics.drawCircle(0, 0, 20);
		dragPoint0.graphics.endFill();
		dragPoint0.name = "dragPoint0";
		
		dragPoint1 = new createjs.Shape();
		dragPoint1.graphics.beginStroke(0);
		dragPoint1.graphics.beginStroke("rgba(255, 255, 255, 0)");
		dragPoint1.graphics.beginFill("rgba(255, 0, 0, 0.5)");
		dragPoint1.graphics.drawCircle(0, 0, 10);
		dragPoint1.graphics.beginFill("rgba(255, 255, 255, 0.01)");
		dragPoint1.graphics.drawCircle(0, 0, 20);
		dragPoint1.graphics.endFill();
		dragPoint1.name = "dragPoint1";
		
		graph0.addChildAt(dragPoint0, 0);
		graph0.addChildAt(dragPoint1, 0);
		
		//単位円のテキスト
		tx0 = createUnitText("x", 16, "#000000", true);
		tx1 = createUnitText("1", 16, "#000000", false);
		tx2 = createUnitText("-1", 16, "#000000", false);
		
		ty0 = createUnitText("y", 16, "#000000", true);
		ty1 = createUnitText("1", 16, "#000000", false);
		ty2 = createUnitText("-1", 16, "#000000", false);
		
		graph0.addChild(tx0);
		graph0.addChild(tx1);
		graph0.addChild(tx2);
		graph0.addChild(ty0);
		graph0.addChild(ty1);
		graph0.addChild(ty2);
		
		changeUnitText();
		
		dotLine = new createjs.Shape();
		cs.addChild(dotLine);
		
		dragPoint0.addEventListener("mousedown", dragPointStart);
		dragPoint1.addEventListener("mousedown", dragPointStart);
		
		
		tTheta = createUnitText("θ", 18, "#007BC6", true);
		graph0.addChild(tTheta);
		
		tTheta.x = 40;
		tTheta.y = 0;
		
		line1 = new createjs.Shape();
		graph1.addChild(line1);
		drawTriangleLine(line1, span, c0, 1, baseCycle, -gW/2+gSpan, gW/2+gSpan, 0);
		
		line2 = new createjs.Shape();
		graph2.addChild(line2);
		drawTriangleLine(line2, span, c1, 1, baseCycle, -gW/2+gSpan, gW/2+gSpan, Math.PI/2);
		
		sinPoint = new createjs.Shape();
		sinPoint.graphics.setStrokeStyle(0);
		sinPoint.graphics.beginStroke(c0);
		sinPoint.graphics.beginFill(c0);
		sinPoint.graphics.drawCircle(0, 0, 4);
		sinPoint.graphics.endStroke();
		graph1.addChild(sinPoint);
		
		cosPoint = new createjs.Shape();
		cosPoint.graphics.setStrokeStyle(0);
		cosPoint.graphics.beginStroke(c1);
		cosPoint.graphics.beginFill(c1);
		cosPoint.graphics.drawCircle(0, 0, 4);
		cosPoint.graphics.endStroke();
		graph2.addChild(cosPoint);
		
		//グラフの座標テキスト
		sinText= [];
		cosText = [];
		for(var i=0; i<=4; i++)
		{
			sinText[i] = new createjs.Container();
			cosText[i] = new createjs.Container();
			graph1.addChild(sinText[i]);
			graph2.addChild(cosText[i]);
		}
		
		changeRadText();
		
		//サインのグラフの座標の点線
		sinLine = new createjs.Shape();
		sinLine.graphics.clear();
		sinLine.graphics.setStrokeStyle(1);
		sinLine.graphics.beginStroke("#888888");
		sinLine.graphics.setStrokeDash([8, 4]);
		for(var i=1; i<=5; i++)
		{
			sinLine.graphics.moveTo(baseCycle/4 * i, 0);
			sinLine.graphics.lineTo(baseCycle/4 * i, -span * Math.sin((90 * i * Math.PI)/180));
		}
		graph1.addChild(sinLine);
		sinLine.visible = false;
		
		//コサインのグラフの座標の点線
		cosLine = new createjs.Shape();
		cosLine.graphics.clear();
		cosLine.graphics.setStrokeStyle(1);
		cosLine.graphics.beginStroke("#888888");
		cosLine.graphics.setStrokeDash([8, 4]);
		for(var i=1; i<=5; i++)
		{
			cosLine.graphics.moveTo(baseCycle/4 * i, 0);
			cosLine.graphics.lineTo(baseCycle/4 * i, -span * Math.sin((90 * (i+1) * Math.PI)/180));
		}
		graph2.addChild(cosLine);
		cosLine.visible = false;
		
		sinTheta = new createjs.Container();
		var st = new createjs.Text("θ", "Italic 18px Times New Roman", "#000000");
		sinTheta.addChild(st);
		st.x = -st.getBounds().width/2;
		st.y = -st.getBounds().height/2;
		graph1.addChild(sinTheta);
		sinTheta.y = 14;
		
		cosTheta = new createjs.Container();
		var ct = new createjs.Text("θ", "Italic 18px Times New Roman", "#000000");
		cosTheta.addChild(ct);
		ct.x = -ct.getBounds().width/2;
		ct.y = -ct.getBounds().height/2;
		graph2.addChild(cosTheta);
		cosTheta.y = 14;
		
		
		//状態の記録
		recData = [];
		
		//角度変更で変わる際の値
		radArray = [];
		for(i=0; i<=450; i+= 15)
		{
			radArray.push(i);
		}
		
		//アニメーションスライダを吹き出しで使用する場合
		slider = new AnimeBalloon(minNum, maxNum, defNum, 250, 40, true, stepSize, changeAnimeGraph, captureData, resetCapture);
		
		document.getElementById("controlBlock").addEventListener("scroll", closeInnerBalloonHandler);
		document.getElementById("menuClose").addEventListener("click", closeInnerBalloonHandler);
		
		animeFlag = false;
		
		document.getElementById("methodText").innerHTML = "弧度法";
		document.getElementById("methodText").addEventListener("click", changeMethodHandler);
		
		$(".lineText").focus(function(){$(this).blur();});
		
		//設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [null, null];
		configArray[2] = [null, null];
		
		
		//単位円の点の調整
		var r = -defNum * Math.PI/180;
		dragPoint0.x = span * Math.cos(r);
		dragPoint0.y = span * Math.sin(r);
		
		dragPoint1.x = span * Math.cos(r - Math.PI/2);
		dragPoint1.y = span * Math.sin(r - Math.PI/2);
		dragPoint1.visible = false;
		
		changeRotShape(rotShape, defNum, true);
		
		changeTrianglePoint();
		
		document.getElementById("check0").checked = true;
		document.getElementById("check0_1").checked = false;
		document.getElementById("check0_2").checked = false;
		document.getElementById("check1").checked = false;
		document.getElementById("check1_1").checked = false;
		document.getElementById("check1_2").checked = false;
		
		graph2.visible = false;
		line1.visible = false;
		line2.visible = false;
		sinPoint.visible = false;
		sinTheta.visible = false;
		cosPoint.visible = false;
		cosTheta.visible = false;
		
		$("#aNum").css("width", "60px");
		
		$("#tMin").css("width", "50px");
		$("#tMax").css("width", "50px");
		
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check0_1").addEventListener("change", changeCheckHandler);
		document.getElementById("check0_2").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check1_1").addEventListener("change", changeCheckHandler);
		document.getElementById("check1_2").addEventListener("change", changeCheckHandler);
		
		document.getElementById('graphRotationBtn').addEventListener('click', playGraphAnimation);
		
		//rotBtn1.addEventListener("click", playGraphAnimation);
		//rotBtn2.addEventListener("click", playGraphAnimation);
		
		document.getElementById('downDataBtn').addEventListener('click', changeDataHandler);
		document.getElementById('upDataBtn').addEventListener('click', changeDataHandler);
		
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		document.getElementById('logoImage').addEventListener('click', resetHandler);
		
		document.getElementById("configBlock").style.display = "none";
		
		setRadiusNumber(document.getElementById("aNum"), slider.prev);
		
		changeRadTextDisplay();
		
		cs.update();
		
		setMenuMode(2, 300);
		
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function setAnimeBalloonPosition()
{
	slider.openAnimeBalloon("aNum");
	/*animeBalloonの三角の位置調整が必要な場合は以下に記述*/
}


function createRotationButton()
{
	try
	{
		var c = new createjs.Container();
		var i = new createjs.Bitmap("./img/rotationBtn.png");
		var s = new createjs.Shape();
		i.scaleX = 30/60;
		i.scaleY = 30/60;
		c.addChild(i);
		
		s.graphics.setStrokeStyle(0);
		s.graphics.beginStroke("rgba(255, 255, 255, 0.02)");
		s.graphics.beginFill("rgba(255, 255, 255, 0.02)");
		s.graphics.drawRect(30, 30);
		s.graphics.endFill();
		s.graphics.endStroke();
		
		c.addChild(s);
		
		return c;
	}
	catch(e)
	{
		alert("createRotationButton:" + e.toString());
	}
}

function createCommonGraphContainer(w, h, s, f)
{
	try
	{
		var graph = new createjs.Container();
		
		var grid = new createjs.Shape();
		grid.name = "grid";
		graph.addChild(grid);
		
		var base = new createjs.Shape();
		base.name = "base";
		graph.addChild(base);
		
		var c0;
		var c1;
		
		if(f)
		{
			c0 = "#007BC6";
			c1 = "#007700";
		}
		else
		{
			c0 = "#000000";
			c1 = "#000000";
		}
		
		//y軸
		base.graphics.setStrokeStyle(0);
		base.graphics.beginStroke(c1);
		base.graphics.beginFill(c1);
		base.graphics.moveTo(0, -h/2);
		base.graphics.lineTo(-3, -h/2+10);
		base.graphics.lineTo(3, -h/2+10);
		base.graphics.lineTo(0, -h/2);
		base.graphics.endFill();
		base.graphics.setStrokeStyle(2);
		base.graphics.moveTo(0, -h/2);
		base.graphics.lineTo(0, h/2);
		
		//θ軸
		base.graphics.setStrokeStyle(0);
		base.graphics.beginStroke(c0);
		base.graphics.beginFill(c0);
		base.graphics.moveTo(w/2+s, 0);
		base.graphics.lineTo(w/2+s-10, -3);
		base.graphics.lineTo(w/2+s-10, 3);
		base.graphics.lineTo(w/2+s, 0);
		base.graphics.endFill();
		base.graphics.setStrokeStyle(2);
		base.graphics.moveTo(-w/2+s, 0);
		base.graphics.lineTo(w/2+s, 0);
		
		base.graphics.endStroke();
		
		var scaleLine =new createjs.Shape();
		scaleLine.name = "scaleLine";
		graph.addChild(scaleLine);
		
		var tX;
		if(f)
		{
			tX = new createjs.Text("x", "Italic 18px Times New Roman", "#000000");
		}
		else
		{
			tX = new createjs.Text("θ", "Italic 18px Times New Roman", "#000000");
		}
		
		if(!f)
		{
			tX.x = w/2-10+s;
			tX.y = 10;
			graph.addChild(tX);

			var tY = new createjs.Text("y", "Italic 18px Times New Roman", "#000000");
			tY.x = 10;
			tY.y = -h/2;
			graph.addChild(tY);

			var tO = new createjs.Text("O", "18px Times New Roman", "#000000");
			tO.x = 5;
			tO.y = 5;
			graph.addChild(tO);
		}
		
		return graph;
	}
	catch(e)
	{
		alert("createGraphContainer:" + e.toString());
	}
}

function drawTriangleLine(line, a, color, size, cycle, min, max, theta)
{
	try
	{
		line.graphics.clear();
		line.graphics.setStrokeStyle(size);
		line.graphics.beginStroke(color);
		
		var f = true;
		
		for(var i=min; i<=max; i++)
		{
			var gY;
			
			gY =  -a * Math.sin(Math.PI * (2*(i%cycle))/cycle + theta);
			
			if(f)
			{
				line.graphics.moveTo(i, gY);
				f = false;
			}
			else
			{
				line.graphics.lineTo(i, gY);
			}
		}
		
	}
	catch(e)
	{
		alert("drawTriangleLine:" + e.toString());
	}
}

function changeTrianglePoint()
{
	try
	{
		var r = slider.prev * Math.PI/180;
		
		sinPoint.x = baseCycle * slider.prev/360;
		sinPoint.y = -span * Math.sin(r);
		
		cosPoint.x = baseCycle * slider.prev/360;
		cosPoint.y = -span * Math.cos(r);
		
		sinTheta.x= sinPoint.x;
		cosTheta.x = cosPoint.x;
	}
	catch(e)
	{
		alert("changeTrianglePoint:" + e.toString());
	}
}

function dragPointStart(e)
{
	try
	{
		if(!animeFlag)
		{
			targetPoint = e.currentTarget;

			cs.addEventListener("pressmove", dragPointMove);
			cs.addEventListener("pressup", dragPointStop);
		}
	}
	catch(e)
	{
		alert("dragPointStart:" + e.toString());
	}
}

function dragPointMove(e)
{
	try
	{
		var mp = graph0.globalToLocal(cs.mouseX, cs.mouseY);
		
		var rad = Math.atan2(mp.y, mp.x);
		
		var f = true;
		
		//cosの点
		if(targetPoint.name == "dragPoint1")
		{
			if(rad <= 0 && rad >= -Math.PI)
			{
				rad += Math.PI/2;
			}
			else if(rad >= Math.PI/2 && rad <= Math.PI)
			{
				rad =(rad-Math.PI)-Math.PI/2;
			}
			else
			{
				rad = rad+Math.PI/2;
			}
		}
		
		rad = -rad * 180/Math.PI;
		

		//上半分でのドラッグ移動の場合
		if(rad >= 0 && rad <= 180)
		{
			//前の状態が270を超えていた場合
			if(slider.prev >= 270)
			{
				rad = 360+rad;

				if(rad >= slider.max)
				{
					rad = slider.max;
				}
			}
		}
		//下半分でのドラッグ移動の場合
		else
		{
			if(slider.prev > 90)
			{
				rad = 360+rad;
			}
		}

		if(rad <= slider.min)
		{
			rad = slider.min;
		}
		else if(rad >= slider.max)
		{
			rad = slider.max;
		}
		
		for(var i=0; i<radArray.length-1; i++)
		{
			if(rad >= slider.min && rad <= slider.max)
			{
				if(rad >= radArray[i] && rad <= radArray[i+1])
				{
					if(rad-radArray[i] <= radArray[i+1]-rad)
					{
						rad = radArray[i];
					}
					else
					{
						rad = radArray[i+1];
					}
					
					break;
				}
			}
		}
		
		if(slider.prev != rad)
		{
			slider.prev = rad;
			
			var t = -rad * Math.PI/180;
			
			dragPoint0.x = span * Math.cos(t);
			dragPoint0.y = span * Math.sin(t);
			
			dragPoint1.x = span * Math.cos(t - Math.PI/2);
			dragPoint1.y = span * Math.sin(t - Math.PI/2);
			
			changeRotShape(rotShape, slider.prev, true);
			changeTrianglePoint();
			
			changeThetaPointText();
			changeCrossPointTextPosition();
			
			changePrevNumberDisplay();
			
			changeDotLine();
			
			slider.changeSliderPoint();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("dragPoinMove:" + e.toString());
	}
}

function dragPointStop(e)
{
	try
	{
		cs.removeEventListener("pressmove", dragPointMove);
		cs.removeEventListener("pressup", dragPointStop);
	}
	catch(e)
	{
		alert("dragPointStop:" + e.toString());
	}
}

function changeRotShape(shape, theta, f)
{
	try
	{
		if(theta >= 0)
		{
			theta = -theta;
		}
		else
		{
			theta = -360+theta;
		}
		
		theta = theta * Math.PI/180;
		
		var leng = 30;
		
		//角度の実線
		shape.graphics.clear();
		shape.graphics.setStrokeStyle(2);
		shape.graphics.beginStroke("#0095DF");
		shape.graphics.moveTo(0, 0);
		shape.graphics.lineTo(span * Math.cos(theta), span*Math.sin(theta));
		
		//回転
		shape.graphics.setStrokeDash(null);
		shape.graphics.setStrokeStyle(0);
		shape.graphics.beginStroke("#0095DF");
		shape.graphics.beginFill("rgba(0, 149, 223, 0.3)");
		shape.graphics.moveTo(0, 0);
		shape.graphics.lineTo(leng, 0);
		
		shape.graphics.arc(0, 0, leng, 0, theta, true);
		
		shape.graphics.endFill();
		shape.graphics.endStroke();
		
		//回転後の場合
		if(rotFlag && ($("#check0").prop("checked") && $("#check1").prop("checked")))
		{
			shape.graphics.setStrokeStyle(2);
			shape.graphics.beginStroke("#0095DF");
			shape.graphics.moveTo(0, 0);
			shape.graphics.lineTo(span * Math.cos(theta-Math.PI/2), span*Math.sin(theta-Math.PI/2));
			
			shape.graphics.setStrokeStyle(1);
			shape.graphics.beginStroke("#0095DF");
			shape.graphics.moveTo(leng/2 * Math.cos(theta), leng/2 * Math.sin(theta));
			shape.graphics.lineTo(Math.sqrt(2) * leng/2 * Math.cos(theta-Math.PI/4), Math.sqrt(2) * leng/2 * Math.sin(theta-Math.PI/4));
			shape.graphics.lineTo(leng/2 * Math.cos(theta-Math.PI/2), leng/2 * Math.sin(theta-Math.PI/2));
		}
		
		shape.graphics.endStroke();
		
		//角度のテキスト
		if(f)
		{
			if(theta <= 0)
			{
				tTheta.x = (leng + 10) * Math.cos(theta/2);
				tTheta.y = (leng + 10) * Math.sin(theta/2);
			}
			else
			{
				tTheta.x = (leng + 10) * Math.cos((2*Math.PI+theta)/2);
				tTheta.y = (leng + 10) * Math.sin((2*Math.PI+theta)/2);
			}
		}
	}
	catch(e)
	{
		alert("changeRotShape:" + e.toString());
	}
}

function playGraphAnimation(e)
{
	try
	{
		if(!animeFlag && $("#check1").prop("checked"))
		{
			animeFlag = true;
			
			dotLine.visible = false;
			
			dragPoint0.visible = false;
			dragPoint1.visible = false;
			
			startGraphAnimation();
		}
	}
	catch(e)
	{
		alert("playGraphAnimation:" + e.toString());
	}
}

function startGraphAnimation()
{
	try
	{
		//　1/5秒ごとに表示変更
		var sec = 100;
		animeTimer = setTimeout(stopGraphAnimation, sec);
	}
	catch(e)
	{
		alert("startGraphAnimation:" + e.toString());
	}
}

function stopGraphAnimation()
{
	try
	{
		clearTimeout(animeTimer);
		
		if(rotFlag)
		{
			graph2.rotation += 5;
		}
		else
		{
			graph2.rotation -= 5;
		}
		
		var r = graph2.rotation * Math.PI/180;
		
		graph2.x = graph0.x + rSpan * Math.cos(r);
		graph2.y = graph0.y + rSpan * Math.sin(r);
		
		if(!$("#check0").prop("checked") && $("#check1").prop("checked"))
		{
			if(rotFlag)
			{
				graph0.rotation += 5;
			}
			else
			{
				graph0.rotation -= 5;
			}
		}
		
		cs.update();
		
		if((rotFlag == false && graph2.rotation == 0) || (rotFlag == true && graph2.rotation == 90))
		{
			animeFlag = false;
			rotFlag = !rotFlag;
			
			changeDragPoint();
			
			changeRotShape(rotShape, slider.prev, true);
			
			dotLine.visible = true;
			changeDotLine();
			
			changeRotationDisplay();
			
			cs.update();
		}
		else
		{
			startGraphAnimation();
		}
	}
	catch(e)
	{
		alert("graphAnimeInterval:" + e.toString());
	}
}

function changeRotationDisplay()
{
	try
	{
		if(rotFlag == true)
		{
			if(!$("#check0").prop("checked") && $("#check1").prop("checked"))
			{
				graph0.rotation = -90;
				
				tTheta.getChildByName("inner").rotation = 90;
			}
			else
			{
				graph0.rotation = 0;
				tTheta.getChildByName("inner").rotation = 0;
			}
		}
		else
		{
			graph0.rotation = 0;
			tTheta.getChildByName("inner").rotation = 0;
		}
		
		changeUnitText();
		
		changeDragPoint();

		changeRotShape(rotShape, slider.prev, true);
		
		changeDotLine();
	}
	catch(e)
	{
		alert("chageRotationDisplay:" + e.toString());
	}
}

function changeDragPoint()
{
	if(rotFlag == true)
	{
		if($("#check0").prop("checked") && $("#check1").prop("checked"))
		{
			dragPoint0.visible = true;
			dragPoint1.visible = true;
		}
		else
		{
			dragPoint0.visible = true;
			dragPoint1.visible = false;
		}
	}
	else
	{
		dragPoint0.visible = true;
		dragPoint1.visible = false;
	}
}


//刻み幅の変更
function changeStepSize(id, num)
{
	try
	{
		stepSize = num;
		
		//設定した刻み幅の倍数に変更
		var n = Math.round(slider.prev/num) * num;
		
		//浮動小数点対策
		n = Math.round(n * 100)/100;
		
		if(n <= slider.min)
		{
			slider.prev = slider.min;
			document.getElementById("aNum").innerHTML = slider.min;
		}
		else if(n >= slider.max)
		{
			slider.prev = slider.max;
			document.getElementById("aNum").innerHTML = slider.max;
		}
		else
		{
			slider.prev = n;
			document.getElementById("aNum").innerHTML = n;
		}
		
		slider.changeSliderPoint();
	}
	catch(e)
	{
		alert("changeStepSize:" + e.toString());
	}
}


function getPointDataString(n, f)
{
	try
	{
		var str;
		
		//数値
		if(f == 0)
		{
			str = n.toString();
		}
		//弧度法
		else if(f == 1)
		{
			var str0 = Math.simplify(n/180).toString();
			
			if(str0 == "0")
			{
				str = "0";
			}
			else if(str0 == "1")
			{
				str = "π";
			}
			else if(str0 == "-1")
			{
				str = "-π";
			}
			else
			{
				str = str0 + "π";
			}
		}
		//度数法
		else
		{
			str = n.toString() + "°";
		}
		
		return str;
	}
	catch(e)
	{
		alert("getPointData");
	}
}

function createPointText(str)
{
	try
	{
		var c = new createjs.Container();
		
		if(str != "")
		{
			changePointText(c, str);
		}
		
		return c;
	}
	catch(e)
	{
		alert("createPointText:" + e.toString());
	}
}

function changePointText(c, str)
{
	try
	{
		//削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		//弧度法
		if(str.indexOf("π") != -1)
		{
			//頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			var t0_1;
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					t0_1 = new createjs.Text(str, "Italic 16px Times New Roman", "#000000");
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str, "16px Times New Roman", "#000000");
					c.addChild(t0_5);
				}
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("changePointText:" + str + "-" + e.toString());
	}
}

function changeAnimeGraph()
{
	try
	{
		//単位円の点の調整
		dragPoint0.x = span * Math.cos(-slider.prev * Math.PI/180);
		dragPoint0.y = span * Math.sin(-slider.prev * Math.PI/180);
		
		dragPoint1.x = span * Math.cos((-slider.prev-90) * Math.PI/180);
		dragPoint1.y = span * Math.sin((-slider.prev-90) * Math.PI/180);
		
		changeRotShape(rotShape, slider.prev, true);
		changeTrianglePoint();
		
		changePrevNumberDisplay();
		
		changeThetaPointText();
		changeCrossPointTextPosition();
		
		changeDotLine();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeAnimeGraph:" + e.toString());
	}
}

function createUnitText(str, size, color, f)
{
	var c = new createjs.Container();
	var inner = new createjs.Container();
	inner.name = "inner";
	c.addChild(inner);
	var t;
	
	if(f)
	{
		t = new createjs.Text(str, "Italic "+size+"px Times New Roman", color);
	}
	else
	{
		t = new createjs.Text(str, size+"px Times New Roman", color);
	}
	
	inner.addChild(t);
	t.x = -t.getBounds().width/2;
	t.y = -t.getBounds().height/2;
	
	return c;
}

function changeUnitText()
{
	try
	{
		tx0.x = span + 22;
		tx0.y = 13;
		
		tx1.x = span + 9;
		tx1.y = 9;
		
		tx2.x = -span + -9;
		tx2.y = 9;
		
		
		ty0.x = 13;
		ty0.y = -span-26;
		
		ty1.x = 9;
		ty1.y = -span-9;
		
		ty2.x = 9;
		ty2.y = span+9;
		
		if(graph0.rotation == 0)
		{
			tx0.getChildByName("inner").rotation = 0;
			tx1.getChildByName("inner").rotation = 0;
			tx2.getChildByName("inner").rotation = 0;
			ty0.getChildByName("inner").rotation = 0;
			ty1.getChildByName("inner").rotation = 0;
			ty2.getChildByName("inner").rotation = 0;
		}
		else
		{
			tx0.getChildByName("inner").rotation = 90;
			tx1.getChildByName("inner").rotation = 90;
			tx2.getChildByName("inner").rotation = 90;
			ty0.getChildByName("inner").rotation = 90;
			ty1.getChildByName("inner").rotation = 90;
			ty2.getChildByName("inner").rotation = 90;
		}
	}
	catch(e)
	{
		alert("changeUnitText:" + e.toString());
	}
}

function captureData()
{
	try
	{
		var array = [];
		
		var f = false;
		var n;
		
		if($("#check0").prop("checked") && $("#check0_1").prop("checked"))
		{
			f = true;
			n = 0;
		}
		
		if($("#check1").prop("checked") && $("#check1_1").prop("checked"))
		{
			if(f == true)
			{
				n = -1;
			}
			else
			{
				n = 1;
				
				f = true;
			}
		}
		
		if(f)
		{
			array = [slider.prev, n];
			
			createCapture(array);
		
			recData.push(array);
		
			cs.update();
		}
	}
	catch(e)
	{
		alert("captureData:" + e.toString());
	}
}

function createCapture(array)
{
	try
	{
		var rad = array[0] * Math.PI/180;
		
		pointArray[pointArray.length] = [];
		
		if(array[1] == -1 || array[1] == 0)
		{
			var p1 = new createjs.Shape();

			p1.graphics.setStrokeStyle(0);
			p1.graphics.beginStroke(c0);
			p1.graphics.beginFill(c0);
			p1.graphics.drawCircle(0, 0, 4);
			p1.graphics.endStroke();

			recCont1.addChild(p1);

			p1.x = baseCycle  * array[0]/360
			p1.y = -span * Math.sin(rad);

			pointArray[pointArray.length-1].push(p1);
		}
		
		if(array[1] == -1 || array[1] == 1)
		{
			var p2 = new createjs.Shape();

			p2.graphics.setStrokeStyle(0);
			p2.graphics.beginStroke(c1);
			p2.graphics.beginFill(c1);
			p2.graphics.drawCircle(0, 0, 4);
			p2.graphics.endStroke();

			recCont2.addChild(p2);

			p2.x = baseCycle  * array[0]/360
			p2.y = -span * Math.cos(rad);

			pointArray[pointArray.length-1].push(p2);
		}
	}
	catch(e)
	{
		alert("createCapture:" + e.toString());
	}
		
}

function resetCapture()
{
	try
	{
		//オブジェクトを削除
		recCont1.removeAllChildren();
		recCont2.removeAllChildren();
		
		//データの削除
		recData = [];
		
		cs.update();
	}
	catch(e)
	{
		alert("resetCapture:" + e.toString());
	}
}


function closeModalHandler(e)
{
	try
	{
		//オプションを閉じる
		if(e.target.id == "optionClose" || e.target.id == "optionCancel")
		{
			
			closeModal();
		}
		//きざみ幅を閉じる
		else
		{
			showModal('optionBlock');
		}
	}
	catch(e)
	{
		alert('modalCloseHandler:' + e.toString());
	}
}

function openAnimeBalloonHandler(e)
{
	try
	{
		slider.openAnimeBalloon(e.target.id);
	}
	catch(e)
	{
		alert("openAnimeBalloonHandler:" + e.toString());
	}
}

function closeInnerBalloonHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert("closeInnerBalloonHandler:" + e.toString());
	}
}

function setSpanHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert('setSpanHandler:' + e.toString());
	}
}

function spanNumberChangeHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert('spanNumberChangeHandler:' + e.toString());
	}
}

function changeModeHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}

function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}


function drawSinLine(line, a, color, size, cycle, min, max, clear)
{
	try
	{
		if(clear)
		{
			line.graphics.clear();
		}
		
		line.graphics.setStrokeStyle(size);
		line.graphics.beginStroke(color);
		
		var f = true;
		
		var pY;
		
		for(var m = min; m<=max; m++)
		{
			pY = -a * (cycle/Math.PI) * Math.sin(Math.PI * (2*(m%cycle))/cycle);
			
			if(f)
			{
				line.graphics.moveTo(m, pY);
				
				f = !f;
			}
			else
			{
				line.graphics.lineTo(m, pY);
			}
		}
		
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawSinLine:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		if(animeFlag == true)
		{
			document.getElementById(e.currentTarget.id).checked = !document.getElementById(e.currentTarget.id).checked;
		}
		else
		{
			switch(e.currentTarget.id)
			{
				case "check0":
					graph1.visible = $("#"+e.currentTarget.id).prop("checked");
					changeRotationDisplay();
					break;

				case "check0_1":
					sinPoint.visible = $("#"+e.currentTarget.id).prop("checked");
					sinTheta.visible = $("#"+e.currentTarget.id).prop("checked");
					recCont1.visible = $("#"+e.currentTarget.id).prop("checked");
					changeDotLine();
					break;

				case "check0_2":
					line1.visible = $("#"+e.currentTarget.id).prop("checked");
					sinLine.visible = $("#"+e.currentTarget.id).prop("checked");
					break;

				case "check1":
					graph2.visible = $("#"+e.currentTarget.id).prop("checked");
					changeRotationDisplay();
					break;

				case "check1_1":
					cosPoint.visible = $("#"+e.currentTarget.id).prop("checked");
					cosTheta.visible = $("#"+e.currentTarget.id).prop("checked");
					recCont2.visible = $("#"+e.currentTarget.id).prop("checked");
					changeDotLine();
					break;

				case "check1_2":
					line2.visible = $("#"+e.currentTarget.id).prop("checked");
					cosLine.visible = $("#"+e.currentTarget.id).prop("checked");
					break;

			}
			
			changeDragPoint();
			
			changeRotShape(rotShape, slider.prev, true);
			
			dotLine.visible = true;
			changeDotLine();
			
			changeRotationDisplay();
			
			changeRadTextDisplay();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

function changeRadTextDisplay()
{
	try
	{
		var leng = sinText.length;
		var f0_1 = $("#check0_1").prop("checked");
		var f0_2 = $("#check0_2").prop("checked");
		var f1_1 = $("#check1_1").prop("checked");
		var f1_2 = $("#check1_2").prop("checked");
		
		for(var i=0; i<leng; i++)
		{
			if(f0_1 && f0_2)
			{
				sinText[i].visible = true;
			}
			else
			{
				sinText[i].visible = false;
			}
			
			if(f1_1 && f1_2)
			{
				cosText[i].visible = true;
			}
			else
			{
				cosText[i].visible = false;
			}
		}
	}
	catch(e)
	{
		alert("changeRadTextDisplay:" + e.toString());
	}
}

function changeCrossPointTextPosition()
{
	try
	{
		return;
	}
	catch(e)
	{
		alert("changeCrossPointTextPosition:" + e.toString());
	}
}

function changeDotLine()
{
	try
	{
		var array = [];
		
		array[0] = graph0.localToGlobal(dragPoint0.x, dragPoint0.y);
		array[1] = graph1.localToGlobal(sinPoint.x, sinPoint.y);
		array[2] = graph1.localToGlobal(sinPoint.x, 0);
		array[3] = graph0.localToGlobal(dragPoint1.x, dragPoint1.y);
		array[4] = graph1.localToGlobal(cosPoint.x, cosPoint.y);
		array[5] = graph1.localToGlobal(cosPoint.x, 0);
		
		
		dotLine.graphics.clear();
		dotLine.graphics.setStrokeStyle(1);
		dotLine.graphics.beginStroke("#888888");
		dotLine.graphics.setStrokeDash([8, 4]);
		
		if($("#check0").prop("checked") && $("#check0_1").prop("checked"))
		{
			dotLine.graphics.moveTo(array[0].x, array[0].y);
			dotLine.graphics.lineTo(array[1].x, array[1].y);
			dotLine.graphics.lineTo(array[2].x, array[2].y);
		}
		
		if($("#check1").prop("checked") && $("#check1_1").prop("checked"))
		{
			if(!rotFlag)
			{
				dotLine.graphics.moveTo(array[0].x, array[0].y);
				
				var rad4 = Math.atan2(array[4].y-graph0.y, array[4].x-graph0.x);
				var leng4 = Math.sqrt((array[4].x-graph0.x)*(array[4].x-graph0.x)+(array[4].y-graph0.y)*(array[4].y-graph0.y));
				var rad5 = Math.atan2(array[5].y-graph0.y, array[5].x-graph0.x);
				var leng5 = Math.sqrt((array[5].x-graph0.x)*(array[5].x-graph0.x)+(array[5].y-graph0.y)*(array[5].y-graph0.y));
				
				dotLine.graphics.lineTo(graph0.x+leng4*Math.cos(rad4+Math.PI/2), graph0.y+leng4*Math.sin(rad4+Math.PI/2));
				dotLine.graphics.lineTo(graph0.x+leng5*Math.cos(rad5+Math.PI/2), graph0.y+leng5*Math.sin(rad5+Math.PI/2));
			}
			else
			{
				if($("#check0").prop("checked"))
				{
					dotLine.graphics.moveTo(array[3].x, array[3].y);
				}
				else
				{
					dotLine.graphics.moveTo(array[0].x, array[0].y);
				}
				
				dotLine.graphics.lineTo(array[4].x, array[4].y);
				dotLine.graphics.lineTo(array[5].x, array[5].y);
			}
		}
		
		dotLine.graphics.endStroke();
	}
	catch(e)
	{
		alert("changeDotLine:" + e.toString());
	}
}

function changeMethodHandler(e)
{
	try
	{
		if(e.currentTarget.innerHTML == "弧度法")
		{
			$("#"+e.currentTarget.id).html("度数法");
		}
		else
		{
			$("#"+e.currentTarget.id).html("弧度法");
		}
		
		setRadiusNumber(document.getElementById("tMin"), slider.min);
		setRadiusNumber(document.getElementById("tMax"), slider.max);
		setRadiusNumber(document.getElementById("aNum"), slider.prev);
		
		changeMethodNumberHandler();
		
		//θ軸のテキスト変更
		changeRadText();
		
		changeCrossPointTextPosition();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeMethodHandler:" + e.toString());
	}
}


function changeDataHandler(e)
{
	try
	{
		var r = slider.prev;
		
		var f = false;
		
		if(e.currentTarget.id=="downDataBtn" && r > slider.min)
		{
			r = radArray[radArray.indexOf(r)-1];
			f = true;
		}
		else if(e.currentTarget.id == "upDataBtn" && r < slider.max)
		{
			r = radArray[radArray.indexOf(r)+1];
			f = true;
		}
		
		if(f)
		{
			slider.prev = r;
			
			t = -r * Math.PI/180;
			
			slider.changeSliderControl();
			slider.changeSliderPoint();
			
			dragPoint0.x = span * Math.cos(t);
			dragPoint0.y = span * Math.sin(t);
			
			dragPoint1.x = span * Math.cos(t - Math.PI/2);
			dragPoint1.y = span * Math.sin(t - Math.PI/2);
			
			changeRotShape(rotShape, slider.prev, true);
			changeTrianglePoint();
			
			changeThetaPointText();
			changeCrossPointTextPosition();
			
			changePrevNumberDisplay();
			
			changeDotLine();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

function changePrevNumberDisplay()
{
	try
	{
		/*
		if(document.getElementById("methodText").innerHTML == "弧度法")
		{
			str = getRadiusTex(slider.prev, true);
		}
		else
		{
			str = getRadiusTex(slider.prev, false);
		}
		
		changeMathJax("aNum", str, false);
		*/
		
		setRadiusNumber(document.getElementById("aNum"), slider.prev);
	}
	catch(e)
	{
		alert("changePrevNumberDisplay:" + e.toString());
	}
}

function changeThetaPointText()
{
	try
	{
		if(document.getElementById("methodText").innerHTML == "度数法")
		{
			/*
			changePointText(lx0, "-180°");
			changePointText(lx1, "-90°");
			changePointText(lx2, "90°");
			changePointText(lx3, "180°");
			*/
		}
		else
		{
			/*
			changePointText(lx0, "-π");
			changePointText(lx1, "-π/2");
			changePointText(lx2, "π/2");
			changePointText(lx3, "π");
			*/
		}
		
	}
	catch(e)
	{
		alert("changeThetaPointText:" + e.toString());
	}
}

function changeGraphScale(sX, sY)
{
	try
	{
		for(var i=0; i<3; i++)
		{
			var base = cs.getChildByName("graph"+i).getChildByName("scaleLine");
			
			base.graphics.clear();

			base.graphics.setStrokeStyle(1);
			base.graphics.beginStroke("#000000");

			//x軸
			base.graphics.moveTo(0, cH/2);
			base.graphics.lineTo(cW, cH/2);

			//y軸
			base.graphics.moveTo(cW/2, 0);
			base.graphics.lineTo(cW/2, cH);

			var i;

			var spanX;
			var spanY;

			//x軸の目盛
			if(sX != null)
			{
				var spanX = span * sX;
				for(i = gW/2-spanX; i>0; i=i-spanX)
				{
					base.graphics.moveTo(i, gH/2-5);
					base.graphics.lineTo(i, gH/2+5);
				}

				for(i = gW/2+spanX; i<gW; i=i+spanX)
				{
					base.graphics.moveTo(i, gH/2-5);
					base.graphics.lineTo(i, gH/2+5);
				}
			}


			//y軸の目盛
			if(sY != null)
			{
				spanY = span * sY;
				for(i = gH/2-spanY; i>0; i=i-spanY)
				{
					base.graphics.moveTo(gW/2-5, i);
					base.graphics.lineTo(gW/2+5, i);
				}

				for(i = gH/2+spanY; i<cH; i=i+spanY)
				{
					base.graphics.moveTo(gW/2-5, i);
					base.graphics.lineTo(gW/2+5, i);
				}
			}
		}
	}
	catch(e)
	{
		alert("changeGraphScale:" + e.toString());
	}
}

function changeGraphGrid(gX, gY)
{
	try
	{
		for(var i=0; i<3; i++)
		{
			var grid = cs.getChildByName("graph"+i).getChildByName("grid");
			
			grid.graphics.clear();
			grid.graphics.setStrokeStyle(0.5);
			grid.graphics.beginStroke("#00A0FF");

			var i;

			var spanX;
			var spanY;

			//x軸の線
			if(gX != null)
			{
				var spanX = span * gX;
				for(i = gW/2-spanX; i>0; i=i-spanX)
				{
					grid.graphics.moveTo(i, 0);
					grid.graphics.lineTo(i, gH);
				}

				for(i = gW/2+spanX; i<gW; i=i+spanX)
				{
					grid.graphics.moveTo(i, 0);
					grid.graphics.lineTo(i, gH);
				}
			}


			//y軸の線
			if(gY != null)
			{
				spanY = span * gY;
				for(i = gH/2-spanY; i>0; i=i-spanY)
				{
					grid.graphics.moveTo(0, i);
					grid.graphics.lineTo(gW, i);
				}

				for(i = gH/2+spanY; i<gH; i=i+spanY)
				{
					grid.graphics.moveTo(0, i);
					grid.graphics.lineTo(gW, i);
				}
			}
		}
	}
	catch(e)
	{
		alert('changeGraphGrid:' + e.toString());
	}
}

function changeRadText()
{
	try
	{
		var str = [];
		
		if(document.getElementById("methodText").innerHTML == "弧度法")
		{
			str[0] = "π/2";
			str[1] = "π";
			str[2] = "3π/2";
			str[3] = "2π";
			str[4] = "5π/2";
		}
		else
		{
			str[0] = "90°";
			str[1] = "180°";
			str[2] = "270°";
			str[3] = "360°";
			str[4] = "450°";
		}
		
		for(var i=0; i<=4; i++)
		{
			changePointText(sinText[i], str[i]);
			changePointText(cosText[i], str[i]);
			
			if(i == 2)
			{
				sinText[i].y = -5 - sinText[i].getBounds().height;
			}
			else
			{
				sinText[i].y = 5;	
			}
			
			sinText[i].x = baseCycle/4 * (i+1) - sinText[i].getBounds().width/2;
			
			
			cosText[i].x = baseCycle/4 * (i+1) - sinText[i].getBounds().width/2;
			cosText[i].y = 5;
		}
	}
	catch(e)
	{
		alert("changeRadText:" + e.toString());
	}
}

function changeFormulaPositionHandler()
{
	return;
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = document.getElementById("check0").checked;
		array[0][1] = document.getElementById("check0_1").checked;
		array[0][2] = document.getElementById("check0_2").checked;
		
		array[0][3] = document.getElementById("check1").checked;
		array[0][4] = document.getElementById("check1_1").checked;
		array[0][5] = document.getElementById("check1_2").checked;
		
		if(document.getElementById("methodText").innerHTML == "弧度法")
		{
			array[1] = true;
		}
		else
		{
			array[1] = false;
		}
		
		array[2] = rotFlag;
		
		//軌跡のデータ
		array[3] = recData.slice();
		
		//アニメーションの設定
		array[4] = [slider.min, slider.max, slider.prev];
		array[5] = slider.loopFlag;
		array[6] = slider.loopMode;
		array[7] = slider.speedIndex;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		document.getElementById("check0").checked = array[0][0];
		graph1.visible = array[0][0];
		
		document.getElementById("check0_1").checked = array[0][1];
		sinPoint.visible = array[0][1];
		sinTheta.visible = array[0][1];
		recCont1.visible = array[0][1];
		
		document.getElementById("check0_2").checked = array[0][2];
		line1.visible = array[0][2];
		sinLine.visible = array[0][2];
		
		document.getElementById("check1").checked = array[0][3];
		graph2.visible = array[0][3];
		
		document.getElementById("check1_1").checked = array[0][4];
		cosPoint.visible = array[0][4];
		cosTheta.visible = array[0][4];
		recCont2.visible = array[0][4];
		
		document.getElementById("check1_2").checked = array[0][5];
		line2.visible = array[0][5];
		cosLine.visible = array[0][5];
		
		if(array[1] == true)
		{
			document.getElementById("methodText").innerHTML = "弧度法";
		}
		else
		{
			document.getElementById("methodText").innerHTML = "度数法";
		}
		
		rotFlag = array[2];
		
		if(rotFlag)
		{
			graph2.x = graph1.x;
			graph2.y = graph1.y;
			graph2.rotation = 0;
		}
		else
		{
			graph2.x = graphX;
			graph2.y = graphY + rSpan;
			graph2.rotation = 90;
		}
		
		//軌跡の設定
		resetCapture();
		
		recData = array[3].slice();
		
		for(var i=0; i<array[3].length; i++)
		{
			createCapture(array[3][i]);
		}
		
		//スライダーの設定
		setSliderData(array[4][0], array[4][1], defNum, array[4][2], true, stepSize);
		
		slider.loopFlag = array[5];
		slider.loopMode = array[6];
		
		switch(array[6])
		{
			case 0:
				document.getElementById("loopBtn").src = "./img/loopIcon.png";
				break;
			case 1:
				document.getElementById("loopBtn").src = "./img/autoIcon.png";
				break;
			case 2:
				document.getElementById("loopBtn").src = "./img/normalIcon.png";
				break;
		}
		
		slider.speedIndex = array[7];
		
		document.getElementById("speedConfig").src = "./img/s" +slider.speedArray[array[7]]+ ".png";
		
		var t = -slider.prev * Math.PI/180;
			
		dragPoint0.x = span * Math.cos(t);
		dragPoint0.y = span * Math.sin(t);

		dragPoint1.x = span * Math.cos(t - Math.PI/2);
		dragPoint1.y = span * Math.sin(t - Math.PI/2);
		
		changeDragPoint();
		
		changeRotShape(rotShape, slider.prev, true);
		changeTrianglePoint();

		changePrevNumberDisplay();

		changeThetaPointText();
		changeCrossPointTextPosition();

		changeRotationDisplay();

		changeRadText();
		
		changeRadTextDisplay();
		
		slider.ss.update();
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			rotFlag = false;
			dragPoint1.visible = false;
			
			document.getElementById("methodText").innerHTML = "弧度法";
			
			configArray[0] = [-30, 360, -10, 10];
			configArray[1] = [null, null];
			configArray[2] = [null, null];
			
			changeMethodNumberHandler();
			
			document.getElementById("check0").checked = true;
			document.getElementById("check0_1").checked = false;
			document.getElementById("check0_2").checked = false;
			document.getElementById("check1").checked = false;
			document.getElementById("check1_1").checked = false;
			document.getElementById("check1_2").checked = false;
			
			graph1.visible = true;
			graph2.visible = false;
			
			line1.visible = false;
			line2.visible = false;
			sinPoint.visible= false;
			sinTheta.visible = false;
			cosPoint.visible= false;
			cosTheta.visible = false;
			sinLine.visible = false;
			cosLine.visible = false;
			
			recCont1.visible = false;
			recCont2.visible = false;
			
			setSliderData(minNum, maxNum, defNum, defNum, true, stepSize);
			
			resetCapture();
			 
			 slider.loopFlag = true;
			 slider.loopMode = 0;
			 document.getElementById("loopBtn").src = "./img/loopIcon.png";
			 
			 slider.speedIndex = 2;
			 document.getElementById('speedConfig').src = "./img/s1.png";
			
			var t = -slider.prev * Math.PI/180;
			
			dragPoint0.x = span * Math.cos(t);
			dragPoint0.y = span * Math.sin(t);
			
			dragPoint1.x = span * Math.cos(t - Math.PI/2);
			dragPoint1.y = span * Math.sin(t - Math.PI/2);
			
			graph2.x = graphX;
			graph2.y = graphY + rSpan;
			graph2.rotation = 90;
			
			changeDragPoint();
			
			changeRotShape(rotShape, slider.prev, true);
			changeTrianglePoint();
			
			changePrevNumberDisplay();
			
			changeThetaPointText();
			changeCrossPointTextPosition();
			
			changeRotationDisplay();
			
			changeRadText();
			
			changeRadTextDisplay();
			
			slider.ss.update();
			cs.update();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
