// JavaScript Document

//	============================================
//	  No 061 ： a_2_P226_001.js
//	  p.226　例1　曲線と接線の囲む図形の方程式
//	============================================

//	+------+
//	| 変数 |
//	+------+

// キャンバス、ステージ
var cc;
var cs;

// キャンバスの幅、高さ
var bW;
var bH;
var cW;
var cH;
var adjW;			// 調整値
var adjH;			// 調整値

// 中心位置
var centerX;
var centerY;

// Ｘ軸、Ｙ軸
var axisX;
var axisY;

// Ｘ軸、Ｙ軸、原点テキスト
var tx;
var ty;
var t0;

// 軸線
var base;

// 方眼
var grid;

// 刻み幅
var stepSize;

// １目盛りのピクセル数
var span;

// １周期のピクセル
var baseCycle;

// グラフ共通の右下の歯車ボタンで使用する設定データ
var configArray;

// 軌跡を制御する場合
var recCont;
var recData;

// アニメーション制御用スライダー
var slider;
var animeFlag;

// ドラッグ関連
var prevX;
var prevY;
var dFlag;
var dotNum;

// 既定値関連
var defMin;
var defMax;
var defNum;

// 図形用
var shp;						// 線、破線、円など
var SHAPE_LINE_0	=	0;		// 二次曲線
var SHAPE_LINE_1	=	1;		// 接線
var SHAPE_LINE_2	=	2;		// 接線
var SHAPE_LINE_3	=	3;		// 座標用破線
var SHAPE_DOT_1		=	4;		// ドット
var SHAPE_DOT_2		=	5;		// ドット
var SHAPE_DOT_3		=	6;		// ドット
var SHAPE_LINE_4	=	7;		// 塗りつぶし用
var SHAPE_MAX		=	8;		// 図形の数
var nameTbl = [ "LINE_0", "LINE_1", "LINE_2", "LINE_3", "DOT_1", "DOT_2", "DOT_3", "LINE_4" ];

// キャンバスに表示するテキスト
var txt;
var TEXT_X1			=	0;		// 値用
var TEXT_Y1			=	1;		// 値用
var TEXT_X2			=	2;		// 値用
var TEXT_Y2			=	3;		// 値用
var TEXT_A			=	4;		// 値用
var TEXT_B			=	5;		// 値用
var TEXT_P			=	6;		// 値用
var TEXT_PX			=	7;
var TEXT_PY			=	8;
var TEXT_L			=	9;
var TEXT_M			=	10;
var TEXT_MAX		=	11;		// テキストの数
var textTbl = [
				{ name:"TEXT_X1", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_Y1", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_X2", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_Y2", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_A" , x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_B" , x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_P" , x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_PX", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_PY", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_L", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
				{ name:"TEXT_M", x:0, y:0, type:1, italic:"", pix:18, pos:"" },
			  ];

var frm0;			// 式表示用
var frm1;			// 式表示用
var frm2;			// 式表示用

// 値保存用
var valX;						// Ｘの値
var valY;						// Ｙの値
var valK;						// 接線の傾き
var valX1;						// Ｘの値
var valY1;						// Ｙの値
var valK1;						// 接線の傾き
var valPX;						// ＰＸの値
var valPY;						// ＰＹの値

var aNum;
var bNum;
var cNum;

var aNum1;
var bNum1;
var cNum1;
var aNum2;
var bNum2;
var cNum2;

var sNum0;
var sNum1;
var sNum2;



//	+----------------+
//	| ロード時の処理 |
//	+----------------+
function loadContentHandler()
{
	try
	{
		// ----------
		// 初期値設定
		// ----------
		
		// １周期のピクセル
		baseCycle = 300;
		
		// 軸の1目盛当たりのピクセル数
		span = 30;
		
		// 刻み幅
		stepSize = 1;
		
		// キャンバス位置調整
		adjW = 140;
		adjH = 90;
		
		// キャンバスサイズ設定
		bW = pageWidth-52;
		bH = pageHeight;
		cW = bW * 3;
		cH = bH * 3;
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		document.getElementById("graphCanvas").style.left = (-bW + adjW) + "px";
		document.getElementById("graphCanvas").style.top = (-bH + adjH) + "px";
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		document.getElementById("graphCanvas").style.position = "absolute";
		
		// 中心位置
		centerX = cW/2;
		centerY = cH/2;
		
		// 値の上限、下限、既定値
		defMin = -12;
		defMax = 12;
		defNum = -11;
		
		// ドラッグ関連
		dFlag = true;
		animeFlag = false;
		
		// 状態の記録エリア
		recData = [];
		
		valX  = -1;
		valY  = 1;
		valX1 = 3;
		valY1 = 9;
		valPX = 0;
		valPY = 0;
		aNum  = 1;
		bNum  = 0;
		cNum  = 0;
		
		// ------------
		// 画面関連設定
		// ------------
		
		// アニメーションスライダを吹き出しで使用する場合
//		slider = new AnimeBalloon( defMin, defMax, defNum, 250, 40, false, stepSize, changeAnimeGraph, captureData, resetCapture );
		
		// ステージの作成
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		// 状態記録のコンテナ作成
		recCont = new createjs.Container();
		cs.addChild(recCont);
		
		// 背景の作成
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		cs.addChild(bg);
		
		// 方眼の作成
		grid = new createjs.Shape();
		cs.addChild(grid);
		
		// 軸と矢印の作成
		base = new createjs.Shape();
		cs.addChild(base);
		axisX = new createjs.Shape();
		cs.addChild(axisX);
		axisY = new createjs.Shape();
		cs.addChild(axisY);
		
		// Ｘ軸、Ｙ軸、原点のテキスト作成
		tx = new createjs.Text("x", "20px Times New Roman", "#000000");
		cs.addChild(tx);
		ty = new createjs.Text("y", "20px Times New Roman", "#000000");
		cs.addChild(ty);
		t0 = new createjs.Text("O", "20px Times New Roman", "#000000");
		cs.addChild(t0);
		
		// キャンパスに表示する図形
		shp = [];
		for ( var i=0; i<SHAPE_MAX; i++ )	{
			shp[i] = new createjs.Shape();
			shp[i].name = nameTbl[i];
			cs.addChild(shp[i]);
		}
		
		// キャンバスに表示するテキスト
		txt = [];
		for ( var i=0; i<TEXT_MAX; i++ )	{
			txt[i] = new createjs.Text("", textTbl[i].italic + " " + textTbl[i].pix + "px Times New Roman", "#000000");
			if ( textTbl[i].pos != "" )		{	txt[i].textAlign = textTbl[i].pos;	}
			cs.addChild(txt[i]);
		}
		
		// 式表示用
		frm0 = new createjs.Container();
		frm0.name = "frm0";
		cs.addChild(frm0);
		frm1 = new createjs.Container();
		frm1.name = "frm1";
		cs.addChild(frm1);
		frm2 = new createjs.Container();
		frm2.name = "frm2";
		cs.addChild(frm2);
		
		$(".lineText").focus(function(){$(this).blur();});
		
		// 入力欄の設定
		document.getElementById("num0X").style.textAlign = "center";
		document.getElementById("num0X").style.width = "30px";
		document.getElementById("num0X").style.display = "inline-block";
		document.getElementById("num1X").style.textAlign = "center";
		document.getElementById("num1X").style.width = "30px";
		document.getElementById("num1X").style.display = "inline-block";
		
		// 設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [null, null];
		configArray[2] = [null, null];
		setGraphConfig();
		
		// チェックボックス
		document.getElementById("check0").checked = true;
		document.getElementById("check1").checked = true;
		document.getElementById("check2").checked = true;
		document.getElementById("checkL").checked = true;
		document.getElementById("checkM").checked = true;
		document.getElementById("checkP").checked = false;
		document.getElementById("check3").checked = false;
		document.getElementById("check4").checked = false;
		document.getElementById("form1").style.display = "none";
		document.getElementById("form2").style.display = "none";
		document.getElementById("form3").style.display = "none";
		document.getElementById("form4").style.display = "none";
		document.getElementById("formL").style.display = "none";
		document.getElementById("formM").style.display = "none";
		
		//-------------
		// リスナー定義
		//-------------
		// リセット
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		// 刻み幅
//		document.getElementById("stepText").addEventListener("click", openMenuBalloonHandler);
		// チェックボックス
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("checkL").addEventListener("change", changeCheckHandler);
		document.getElementById("checkM").addEventListener("change", changeCheckHandler);
		document.getElementById("checkP").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		document.getElementById("check4").addEventListener("change", changeCheckHandler);
		// 隠しボタン
		document.getElementById("hidenBtn0").addEventListener("click", changeHidenBtnHandler);
		document.getElementById("hidenBtn1").addEventListener("click", changeHidenBtnHandler);
		document.getElementById("hidenBtnL").addEventListener("click", changeHidenBtnHandler);
		document.getElementById("hidenBtnM").addEventListener("click", changeHidenBtnHandler);
		// ドットのドラッグ
		shp[SHAPE_DOT_1].addEventListener("mousedown", dotDragStart);
		shp[SHAPE_DOT_2].addEventListener("mousedown", dotDragStart);
		// キャンバスのドラッグ
		cs.addEventListener("mousedown", canvasDragStart);
		// オプションボタン（数式の設定画面）
		document.getElementById('optionBtn0').addEventListener('click', openOptionHandler);
		document.getElementById('optionClose').addEventListener('click', closeOptionHandler);
		// 数式の設定
		document.getElementById("upBtn0_0").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_1").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_2").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_0").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_1").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_2").addEventListener("click", changeFormulaHandler);
		// 値の設定
		document.getElementById("upBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn1").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn1").addEventListener("click", changeDataHandler);
		
		//-------------
		// 画面初期表示
		//-------------
		
		// 使用しないバルーン・非表示
		document.getElementById("selectBalloon_menu").style.display = "none";			// 刻み幅
		document.getElementById("selectBalloon_config").style.display = "none";			// 設定画面
		document.getElementById("animeBalloon").style.display = "none";					// アニメ
		
		// スライダー設定
//		document.getElementById("loopBtn").src = "./img/loopIcon.png";
//		document.getElementById('speedConfig').src = "./img/s1.png";
//		slider.min = defMin;
//		slider.max = defMax;
//		slider.prev = defNum;
//		slider.loopFlag = false;
//		slider.loopMode = 0;
//		slider.speedIndex = 2;
//		slider.changeSliderLine();
//		slider.changeSliderPoint();
//		slider.changeSliderControl();
		
		// 刻み幅
//		document.getElementById("stepText").innerHTML = stepSize;
		
		// 値
		document.getElementById("num0x").innerHTML = valX;
		document.getElementById("num0y").innerHTML = valY;
		document.getElementById("num1x").innerHTML = valX1;
		document.getElementById("num1y").innerHTML = valY1;
		document.getElementById("num0X").innerHTML = valX;
		document.getElementById("num1X").innerHTML = valX1;
		
		// 軸表示
		drawBaseLine();
		changeAxisPositionHandler();
		
		// 計算処理
		calcData();
		
		// 式の表示
		drawFormula();
		
		// 図形の表示
		drawShape();
		
		// テキストの表示
		drawText();
		
		// オプションメニュー画面
		setModal('optionBlock');
		setModal('spanChange');
		setMenuMode(0, 320);
		$("#controlBlock").css("overflow-x", "hidden");		// 横スクロールバーは非表示
		
		// ステージ更新
		cs.update();
		
		// バージョンチェック
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

//	+------------------------------------+
//	| 以下は必要なので削除してはいけない |
//	+------------------------------------+

//	+--------------------------+
//	| アニメ制御画面のオープン |
//	+--------------------------+
function setAnimeBalloonPosition()
{
//	document.getElementById("animeTriangle").style = "position:relative;left:40px";
}

//	+----------------+
//	| アニメーション |
//	+----------------+
function changeAnimeGraph()
{
//	slider.ss.update();
//	cs.update();
}

//	+--------------+
//	|  |
//	+--------------+
function changeFormulaPositionHandler(num)
{
	return;
}
//	+--------------+
//	|  |
//	+--------------+
function captureData()
{
	try
	{
//		createcaptureData();
//		cs.update();
	}
	catch(e)
	{
		alert("captureData:" + e.toString());
	}
}

//	+--------------+
//	|  |
//	+--------------+
function createcaptureData(n)
{
	try
	{
//		var s = new createjs.Shape();
//		s.name = "s" + recData.length;
//		cs.addChild(s);
//		
//		s.x = cW/2;
//		s.y = cH/2;
//		s.alpha = 0.25;
//		
//		drawDot( s, qx, qy, "orange", s.alpha);
//		
//		recCont.addChild(s);
//		recData.push(n);
//		cs.update();
	}
	catch(e)
	{
		alert("createcaptureData:" + e.toString());
	}
		
}

//	+--------------+
//	|  |
//	+--------------+
function resetCapture()
{
	try
	{
//		var leng = recData.length;
//		//オブジェクトを削除
//		recCont.removeAllChildren();
//		//データの削除
//		recData = [];
//		cs.update();
	}
	catch(e)
	{
		alert("resetCapture:" + e.toString());
	}
}
//	+----------------------------------------+
//	| ここまでは必要なので削除してはいけない |
//	+----------------------------------------+

//	+--------------------+
//	| ベースラインの描画 |
//	+--------------------+
function drawBaseLine()
{
	try
	{
		// 軸と矢印の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		// Ｘ軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		// Ｙ軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		// Ｘ軸の矢印
		axisX.graphics.beginFill("#000000");
		axisX.graphics.moveTo(-20, 0);
		axisX.graphics.lineTo(-20, -4);
		axisX.graphics.lineTo(-2, 0);
		axisX.graphics.lineTo(-20, 4);
		axisX.graphics.lineTo(-20, 0);
		axisX.graphics.endFill();
		// Ｙ軸の矢印
		axisY.graphics.beginFill("#000000");
		axisY.graphics.moveTo(0, 20);
		axisY.graphics.lineTo(-4, 20);
		axisY.graphics.lineTo(0, 2);
		axisY.graphics.lineTo(4, 20);
		axisY.graphics.lineTo(0, 20);
		axisY.graphics.endFill();
		axisY.graphics.endStroke();
		// Ｘ軸、Ｙ軸の位置
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		numX = -numX.substring(0, numX.length-2);
		numY = -numY.substring(0, numY.length-2);
		axisX.x = numX + bW;
		axisX.y = centerY;
		axisY.x = centerX;
		axisY.y = numY;
		// Ｘ軸、Ｙ軸、原点のテキスト
		tx.x = numX + bW -tx.getBounds().width-5;
		tx.y = cH/2+5;
		ty.x = cW/2+10;
		ty.y = numY + 2;
		t0.x = cW/2+5;
		t0.y = cH/2+5;
	}
	catch(e)
	{
		alert("drawBase:"+e.toString());
	}
}

//	+----------+
//	| 軸の表示 |
//	+----------+
function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(axisX.x-2, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, axisY.y+2);
		base.graphics.lineTo(cW/2, cH);
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}

//	+----------+
//	| 計算処理 |
//	+----------+
function calcData()
{
	try
	{
		valY = func_X(valX);
		valK = func_X2(valX);
		document.getElementById("num0x").innerHTML = Math.round(valX*100)/100;
		document.getElementById("num0y").innerHTML = Math.round(valY*100)/100;
		document.getElementById("num0X").innerHTML = Math.round(valX*100)/100;
		valY1 = func_X(valX1);
		valK1 = func_X2(valX1);
		document.getElementById("num1x").innerHTML = Math.round(valX1*100)/100;
		document.getElementById("num1y").innerHTML = Math.round(valY1*100)/100;
		document.getElementById("num1X").innerHTML = Math.round(valX1*100)/100;
		var pt = calcCrossPoint(valK,-1,(-valX*valK+valY),valK1,-1,(-valX1*valK1+valY1));
		valPX  = pt[0].x;
		valPY  = pt[0].y;
		
		sNum0 = func_S( valX,  valPX );
		sNum1 = func_S( valPX, valX1 );
		sNum2 = sNum0 + sNum1;
		
		func_F1();
		func_F2();
		
	}
	catch(e)
	{
		alert("calcData:" + e.toString());
	}
}

function func_X(x)
{
 	return ( aNum * x * x + bNum * x + cNum );
}
function func_X2(x)
{
 	return ( aNum * x * 2 + bNum );
}
function func_S(x1,x2)
{
	var x = x2 - x1;
	var num = Math.abs( aNum * x * x * x ) / 3;
	num = Math.round(num*100)/100;
 	return num;
}
function func_F1()
{
 	aNum1 = 0;
 	bNum1 = valK;
 	cNum1 = -valX*valK+valY;
}
function func_F2()
{
 	aNum2 = 0;
 	bNum2 = valK1;
 	cNum2 = -valX1*valK1+valY1; 
}

//	+------------+
//	| 図形の表示 |
//	+------------+
function drawShape()
{
	try
	{
		for ( var i=0; i<SHAPE_MAX; i++ )		{	shp[i].graphics.clear();	}
		
		// 曲線の式
		if ( document.getElementById("check0").checked )
		{
			drawGraph_1( shp[SHAPE_LINE_0], "black", 1 );
		}
		
		// 座標線１
		if ( document.getElementById("check1").checked )
		{
			drawPosLine( shp[SHAPE_LINE_3], valX, valY, "black", 0.5 );
			drawDot( shp[SHAPE_DOT_1], valX, valY, "red", 0.5);
		}
		
		// 座標線２
		if ( document.getElementById("check2").checked )
		{
			drawPosLine( shp[SHAPE_LINE_3], valX1, valY1, "black", 0.5 );
			drawDot( shp[SHAPE_DOT_2], valX1, valY1, "red", 0.5);
		}
		
		// 接線１
		if( document.getElementById("checkL").checked )
		{
			var x1 = -10000;
			var y1 = bNum1 * x1 + cNum1;
			var x2 = 10000;
			var y2 = bNum1 * x2 + cNum1;
			drawLine_3( shp[SHAPE_LINE_1], x1, y1, x2, y2, "blue", 1 );
		}
		
		// 接線２
		if( document.getElementById("checkM").checked )
		{
			var x1 = -10000;
			var y1 = bNum2 * x1 + cNum2;
			var x2 = 10000;
			var y2 = bNum2 * x2 + cNum2;
			drawLine_3( shp[SHAPE_LINE_2], x1, y1, x2, y2, "blue", 1 );
		}
		
		if ( document.getElementById("checkP").checked )
		{
			drawPosLine( shp[SHAPE_LINE_3], valPX, valPY, "black", 0.5 );
			drawDot( shp[SHAPE_DOT_3], valPX, valPY, "brack", 0.5);
		}
		
		if ( document.getElementById("check3").checked )
		{
			drawGraph_2( shp[SHAPE_LINE_4], valX, valPX, 0, "blue", 0.1 );
		}
		if ( document.getElementById("check4").checked )
		{
			drawGraph_2( shp[SHAPE_LINE_4], valPX, valX1, 1, "pink", 0.1 );
		}
	}
	catch(e)
	{
		alert("drawShape:" + e.toString());
	}
}

//	+----------------+
//	| テキストの表示 |
//	+----------------+
function drawText()
{
	try
	{
		for ( var i=0; i<TEXT_MAX; i++ )	{	txt[i].visible = false;	}
		
		var x;
		var y;
		var str;
		
		frm0.visible = false;
		if ( document.getElementById("check0").checked )
		{
			// 元の式
			for ( x=10; x<=10; x-=0.1 )
			{
				y = func_X(x);
				if ( y > 2 && y < 4 )	break;
				if ( y < -2 && y > -4 )	break;
			}
			changeFormulaContainer( frm0, "y=" + editForm3(aNum,bNum,cNum), centerX + x * span - 8, centerY - y * span, "R" );
			frm0.visible = true;
		}
		
		if ( document.getElementById("check1").checked )
		{
			// 点Ａ
			txt[TEXT_A].text = "A";
			txt[TEXT_A].x = centerX + valX * span;
			txt[TEXT_A].y = centerY - valY * span;
			txt[TEXT_A].visible = true;
			// 座標値
			txt[TEXT_X1].text = Math.round( valX * 100 ) / 100;
			txt[TEXT_Y1].text = Math.round( valY * 100 ) / 100;
			drawPosText(txt[TEXT_X1],txt[TEXT_Y1]);
			txt[TEXT_X1].visible = true;
			txt[TEXT_Y1].visible = true;
		}
		
		if ( document.getElementById("check2").checked )
		{
			// 点Ｂ
			txt[TEXT_B].text = "B";
			txt[TEXT_B].x = centerX + valX1 * span;
			txt[TEXT_B].y = centerY - valY1 * span;
			txt[TEXT_B].visible = true;
			// 座標値
			txt[TEXT_X2].text = Math.round( valX1 * 100 ) / 100;
			txt[TEXT_Y2].text = Math.round( valY1 * 100 ) / 100;
			drawPosText(txt[TEXT_X2],txt[TEXT_Y2]);
			txt[TEXT_X2].visible = true;
			txt[TEXT_Y2].visible = true;
		}
		
		frm1.visible = false;
		if( document.getElementById("checkL").checked )
		{
			// 接線の式１
			if ( valK == 0 )	{	str = "y=" + Math.round(valY*100)/100		}
			else				{	str = "y=" + editForm3(aNum1,bNum1,cNum1);	}
			var pos = getFormulaPosition( bNum1, -1, cNum1, "L" );
			changeFormulaContainer( frm1, str, centerX + pos.x * span, centerY - pos.y * span, "R" );
			frm1.visible = true;
		}
		
		frm2.visible = false;
		if( document.getElementById("checkM").checked )
		{
			// 接線の式２
			if ( valK1 == 0 )	{	str = "y=" + Math.round(valY1*100)/100;		}
			else				{	str = "y=" + editForm3(aNum2,bNum2,cNum2);	}
			var pos = getFormulaPosition( bNum2, -1, cNum2, "R" );
			changeFormulaContainer( frm2, str, centerX + pos.x * span, centerY - pos.y * span, "L" );
			frm2.visible = true;
		}
		
		if ( document.getElementById("checkP").checked )
		{
			// 点Ｐ
			txt[TEXT_P].text = "P";
			txt[TEXT_P].x = centerX + valPX * span;
			txt[TEXT_P].y = centerY - valPY * span;
			txt[TEXT_P].visible = true;
			
			// 座標値
			txt[TEXT_PX].text = Math.round( valPX * 100 ) / 100;
			txt[TEXT_PY].text = Math.round( valPY * 100 ) / 100;
			drawPosText(txt[TEXT_PX],txt[TEXT_PY]);
			txt[TEXT_PX].visible = true;
			txt[TEXT_PY].visible = true;
		}
		
	}
	catch(e)
	{
		alert("drawText:" + e.toString());
	}
}

// +------------+
// | 数式の編集 |
// +------------+
function changeFormulaContainer(frm, str, x, y, pos)
{
	if ( str == "" )	{	return;		}
	
	array = [ "x", "y", "k" ];			// 斜体にしたい文字をここにセットする
	
	var w = changeFormulaStringContainer(frm, str, array, 18, "");
	if ( pos == "R" || pos == "r" )		{	frm.x = x - w;	}
	else								{	frm.x = x;		}
	frm.y = y;
	frm.visible = true;

}

// +------------------------+
// | テキストの表示位置計算 |
// +------------------------+
function getFormulaPosition(a,b,c,pos)
{
	var x;
	var y;
	var k;
	var cx = ( -adjW + 120 ) / span;
	var cy = adjH / span;
	var size = 0.1;
	var minX = -4;
	var maxX = 4;
	var minY = -3.5;
	var maxY = 10;
	
	if ( pos != "L" && pos != "R" )		{	pos = "R";	}
	
	// 垂直の場合
	if ( b == 0 )
	{
		if ( pos == "L" )		{	y = minY;	}
		if ( pos == "R" )		{	y = maxY;	}
		x = getX( a, b, c, y );	
		return { x:x, y:y };
	}
	
	// 水平の場合
	if ( a == 0 )
	{
		if ( pos == "L" )		{	x = minX;	}
		if ( pos == "R" )		{	x = maxX;	}
		y = getY( a, b, c, x );	
		return { x:x, y:y };
	}
	
	// 傾き
	var k = a / b;
	
	// 垂直方向に近い
	if ( Math.abs(k) > 1 )
	{
		// 左側に表示
		if ( pos == "L" )
		{
			// 左下がり
			if ( k <= 0 )
			{
				for ( y=minY; y<=maxY; y+=size )
				{
					x = getX( a, b, c, y );	
					if ( x >= minX )	{	break;	}
				}
				y -= size;
			}
			// 左上がり
			else
			{
				for ( y=maxY; y>=minY; y-=size )
				{
					x = getX( a, b, c, y );	
					if ( x >= minX )	{	break;	}
				}
				y += size;
			}
		}
		// 右側に表示
		if ( pos == "R" )
		{
			// 右上がり
			if ( k <= 0 )
			{
				for ( y=maxY; y>=minY; y-=size )
				{
					x = getX( a, b, c, y );	
					if ( x <= maxX )	{	break;	}
				}
				y += size;
			}
			// 右下がり
			else
			{
				for ( y=minY; y<=maxY; y+=size )
				{
					x = getX( a, b, c, y );	
					if ( x <= maxX )	{	break;	}
				}
				y -= size;
			}
		}
	}
	// 水平方向に近い
	else
	{
		// 左側に表示
		if ( pos == "L" )
		{
			// 左下がり
			if ( k <= 0 )
			{
				for ( x=minX; x<=maxX; x+=size )
				{
					y = getY( a, b, c, x );	
					if ( y >= minY )	{	break;	}
				}
				x -= size;
			}
			// 左上がり
			else
			{
				for ( x=minX; x<=maxX; x+=size )
				{
					y = getY( a, b, c, x );	
					if ( y <= maxY )	{	break;	}
				}
				x -= size;
			}
		}
		// 右側に表示
		if ( pos == "R" )
		{
			// 右上がり
			if ( k <= 0 )
			{
				for ( x=maxX; x>=minX; x-=size )
				{
					y = getY( a, b, c, x );	
					if ( y <= maxY )	{	break;	}
				}
				x += size;
			}
			// 右下がり
			else
			{
				for ( x=maxX; x>=minX; x-=size )
				{
					y = getY( a, b, c, x );	
					if ( y >= minY )	{	break;	}
				}
				x += size;
			}
		}
	}
	return { x:x, y:y };
}
function getY(a,b,c,x)
{
	return ( ( a * x + c ) / -b );
}
function getX(a,b,c,y)
{
	return ( ( b * y + c ) / -a );
}

//	+--------------+
//	| 式や値の表示 |
//	+--------------+
function drawFormula()
{
	try
	{
		var str;
		var num;
		str = "\\small{y=" + editForm3(aNum,bNum,cNum) + "}";
		changeMathJax( "form0", str, false );
		
		if ( document.getElementById("form1").style.display == "" )
		{
			str = "\\small{\\int_{" + valX + "}^{" + valPX + "} \\{";
			str += editForm3(aNum,bNum,cNum) + "-(";
			str += editForm3(aNum1,bNum1,cNum1) + ") \\}dx";
			str += "}";
			changeMathJax( "form1", str, false );
			str = "\\small{= " + sNum1 + "}";
			changeMathJax( "form3", str, false );
		}
		
		if ( document.getElementById("form2").style.display == "" )
		{
			str = "\\small{\\int_{" + valPX + "}^{" + valX1 + "} \\{";
			str += editForm3(aNum,bNum,cNum) + "-(";
			str += editForm3(aNum2,bNum2,cNum2) + ") \\}dx";
			str += "}";
			changeMathJax( "form2", str, false );
			str = "\\small{= " + sNum1 + "}";
			changeMathJax( "form4", str, false );
		}
		
		if( document.getElementById("formL").style.display == "")
		{
			if ( valK == 0 )	{	str = "\\small{" + "y=" + Math.round(valY) +  "}";				}
			else				{	str = "\\small{" + "y=" + editForm3(aNum1,bNum1,cNum1) + "}";	}
			changeMathJax( "formL", str, false );
		}
		if( document.getElementById("formM").style.display == "")
		{
			if ( valK1 == 0 )	{	str = "\\small{" + "y=" + Math.round(valY1) +  "}";				}
			else				{	str = "\\small{" + "y=" + editForm3(aNum2,bNum2,cNum2) + "}";	}
			changeMathJax( "formM", str, false);
		}
	}
	catch(e)
	{
		alert("drawFormula:" + e.toString());
	}
}

//	+----------+
//	| 式の編集 |
//	+----------+
function editForm(a,b,c,f)
{
	try
	{
		var str = "";
		switch( a )
		{
			case 0:
				break;
			case -1:
				str += "<span class='uTimes'>-</span><span class='times'>x</span>";
				break;
			case 1:
				str += "<span class='times'>x</span>";
				break;
			default:
				str += "</span><span class='uTimes'>" + a + "</span><span class='times'>x</span>";
				break;
		}
		
		switch( b )
		{
			case 0:
				break;
			case -1:
				if ( a == 0 )	{	str += "<span class='times'>y</span>";											}
				else			{	str += "<span class='uTimes'> - </span><span class='times'>y</span>";		}
				break;
			case 1:
				if ( a == 0 )	{	str += "<span class='times'>y</span>";											}
				else			{	str += "<span class='uTimes'> + </span><span class='times'>y</span>";		}
				break;
			default:
				if ( a == 0 )
				{
					str += "<span class='uTimes'>" + b + "</span><span class='times'>y</span>";
				}
				else
				{
					if ( b > 0 )	{	str += "<span class='uTimes'> + " + Math.abs(b) + "</span><span class='times'>y</span>";	}
					else			{	str += "<span class='uTimes'> - " + Math.abs(b) + "</span><span class='times'>y</span>";	}
				}
				break;
		}
		switch( f )
		{
			case "none":
				break;
			case "= 0":
			case "> 0":
			case "< 0":
			case "≧ 0":
			case "≦ 0":
				if ( c > 0 )	{	str += "<span class='uTimes'> + " + Math.abs(c) + "</span>";	}
				if ( c < 0 )	{	str += "<span class='uTimes'> - " + Math.abs(c) + "</span>";	}
				str += "</span><span class='uTimes'> " + f + "</span>";
				break;
			case "1":
				if ( c > 0 )	{	str += "<span class='uTimes'> + " + Math.abs(c) + "</span>";	}
				if ( c < 0 )	{	str += "<span class='uTimes'> - " + Math.abs(c) + "</span>";	}
				break;
			default:
				str += "</span><span class='uTimes'> " + f + " " + -c + "</span>";
				break;
		}
		return str;
	}
	catch(e)
	{
		alert("editForm:" + e.toString());
	}
}

//	+------------+
//	| 式の編集２ |
//	+------------+
function editForm2(a,b,c)
{
	try
	{
		var str = "y=";
		if ( a == 0 )
		{
			str += c;
		}
		else
		{
			if ( b == 0 )
			{
				str += "0";
			}
			else
			{
				if ( b >= 0 )
				{
					var ab = Math.round( -a / b * 100 ) / 100;
					var cb = Math.round( -c / b * 100 ) / 100;
					if ( ab == 1 || ab == -1 )
					{
						if ( ab == 1 )	{	str += "x";		}
						else			{	str += "-x";	}
					}
					else
					{
						str += ab + "x";
					}
					if ( cb > 0 )	{	str += "+" + Math.abs( cb );	}
					if ( cb < 0 )	{	str += "-" + Math.abs( cb );	}
				}
				else
				{
					var ab = Math.round( a / -b * 100 ) / 100;
					var cb = Math.round( c / -b * 100 ) / 100;
					if ( ab == 1 || ab == -1 )
					{
						if ( ab == 1 )	{	str += "x";		}
						else			{	str += "-x";	}
					}
					else
					{
						str += ab + "x";
					}
					if ( cb > 0 )	{	str += "+" + Math.abs( cb );	}
					if ( cb < 0 )	{	str += "-" + Math.abs( cb );	}
				}
			}
		}
		return str;
	}
	catch(e)
	{
		alert("editForm2:" + e.toString());
	}
}

//	+------------+
//	| 式の編集３ |
//	+------------+
function editForm3(aa,bb,cc)
{
	try
	{
		var str = "";
		var a = Math.round(aa*100)/100;
		var b = Math.round(bb*100)/100;
		var c = Math.round(cc*100)/100;
		
		if ( a != 0 )
		{
			if ( Math.abs(a) != 1 )	{	str += a;	}
			str += "x²";
		}
		if ( b != 0 )
		{
			if ( b < 0 )	{	str += "-";	}
			else			{	str += "+";	}
			if ( Math.abs(b) != 1 )	{	str += Math.abs(b);	}
			str += "x";
		}
		if ( c != 0 )
		{
			if ( c < 0 )	{	str += "-";	}
			else			{	str += "+";	}
			str += Math.abs(c);
		}
		if ( str.indexOf("+") == 0 )	{	str = str.substr(1);	}
		
		return str;
	}
	catch(e)
	{
		alert("editForm3:" + e.toString());
	}
}

//	+--------------+
//	| ドットの表示 |
//	+--------------+
function drawDot(dot,x,y,color,alpha)
{
	try
	{
		var col = "rgba(0,0,0," + alpha + ")";
		switch( color )
		{
			case "gray":
				col = "rgba(32,32,32," + alpha + ")";
				break;
			case "blue":
				col = "rgba(0,122,197," + alpha + ")";
				break;
			case "red":
				col = "rgba(255,0,0," + alpha + ")";
				break;
			case "orange":
				col = "rgba(255,127,0," + alpha + ")";
				break;
		}
		
		var x = centerX + x * span;
		var y = centerY - y * span;
		dot.graphics.setStrokeStyle(1);
		dot.graphics.beginStroke("rgba(255, 255, 255, 0.02)");
		dot.graphics.beginFill(col);
		dot.graphics.drawCircle(x, y, 5);
		dot.graphics.beginFill("rgba(255, 255, 255, 0.02)");
		dot.graphics.drawCircle(x, y, 15);
		dot.graphics.endFill();
		dot.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawDot:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示１ |
//	+--------------+
function drawLine_1(line, a, b, c, col, alpha)
{
	try
	{
		// 傾き(軸の方向注意)
		var pA = a / b;
		
		// 切片(軸の方向注意)
		var pB = c / b;
		
		line.graphics.setStrokeStyle(1);
		
		// 色
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 122, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		
		// 縦の線
		if ( b == 0 )
		{
			line.graphics.moveTo(0, -cH);
			line.graphics.lineTo(0, cH);
			line.x = cW/2 + (-c/a) * span;
			line.y = cH/2;
		}
		// 横の線
		else if ( a == 0 )
		{
			line.graphics.moveTo(-cW, 0);
			line.graphics.lineTo(cW, 0);
			line.x = cW/2;
			line.y = cH/2 + pB * span;
		}
		else
		{
			line.graphics.moveTo(-cH/ pA, -cH);
			line.graphics.lineTo(cH/ pA, cH);
			line.x = cW/2;
			line.y = cH/2 + pB  * span;
			
		}
		
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLineHandler:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示２ |
//	+--------------+
function drawLine_2(line,xx1,yy1,xx2,yy2,col,alpha)
{
	try
	{
		var k = ( x2 - x1 ) / ( y2 - y1 ) * 2000;
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 122, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span + k, centerY - yy1 * span + 2000);
		line.graphics.lineTo( centerX + xx2 * span - k, centerY - yy2 * span - 2000);
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLineHandler:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示３ |
//	+--------------+
function drawLine_3(line,xx1,yy1,xx2,yy2,col,alpha)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 122, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span, centerY - yy1 * span);
		line.graphics.lineTo( centerX + xx2 * span, centerY - yy2 * span);
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLineHandler:" + e.toString());
	}
}

//	+---------------------+
//	| グラフ（y=x²)の表示 |
//	+---------------------+
function drawGraph_1(line,col,alpha)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		var x = -10;
		var y = x * x;
		switch( col )
		{
			case "glay":
				fillColor = "rgba( 192, 192, 192, " + alpha + " )";
				break;
			case "blue":
				color = "rgba( 0, 122, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		line.graphics.moveTo( centerX + x * span, centerY - y * span );
		for ( var x=-99; x<=10; x+=0.1 )
		{
			y = func_X(x);
			line.graphics.lineTo( centerX + x * span, centerY - y * span );
		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawGraph1:" + e.toString());
	}
}

//	+----------------+
//	| 塗りつぶし表示 |
//	+----------------+
function drawGraph_2(line,sx,ex,f,col,alpha)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "glay":
				fillColor = "rgba( 192, 192, 192, " + alpha + " )";
				break;
			case "blue":
				color = "rgba( 0, 122, 197, " + alpha + " )";
				break;
			case "green":
				color = "rgba( 0, 119, 0, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			case "pink":
				color = "rgba(255, 80, 128, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		for ( var x=sx; x<=ex; x+=0.01 )
		{
			var y = func_X(x);
			line.graphics.moveTo( centerX + x * span, centerY - y * span );
			if ( f == 0 )
			{
				y = valK * x - valK * valX + valY;
			}
			else
			{
				y = valK1 * x - valK1 * valX1 + valY1;
			}
			line.graphics.lineTo( centerX + x * span, centerY - y * span );
		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawGraph_2:" + e.toString());
	}
}

//	+--------------+
//	| 座標線の表示 |
//	+--------------+
function drawRightAngleSymbol(line,x1,y1,x2,y2,dir,col,alpha)
{
	try
	{
		var th = Math.atan2( (x2-x1)*dir, (y2-y1)*dir );
		var p0 = Math.PI / 4 * dir;
		var p1 = Math.PI / 2 * dir;
		var r = Math.sqrt( (x2-x1) * (x2-x1) + (y2-y1) * (y2-y1) ) * 0.1;
		if ( r > 0.1 )		{	r = 0.4;	}
		var xx1 = x1 - Math.cos(th) * r;
		var yy1 = y1 - Math.sin(th) * r;
		var xx2 = x1 - Math.cos(th-p0) * r * Math.sqrt(2);
		var yy2 = y1 - Math.sin(th-p0) * r * Math.sqrt(2);
		var xx3 = x1 - Math.cos(th-p1) * r;
		var yy3 = y1 - Math.sin(th-p1) * r;
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 122, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span, centerY - yy1 * span );
		line.graphics.lineTo( centerX + xx2 * span, centerY - yy2 * span );
		line.graphics.lineTo( centerX + xx3 * span, centerY - yy3 * span );
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawRightAngleSymbol:" + e.toString());
	}
}

//	+--------------+
//	| 座標線の表示 |
//	+--------------+
function drawPosLine(line,x,y,col,alpha)
{
	try
	{
		var x1 = centerX + x * span;
		var y1 = centerY - y * span;
		line.graphics.setStrokeStyle(1);
		line.graphics.setStrokeDash([5, 5], 0);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 122, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX, y1 );
		line.graphics.lineTo( x1, y1 );
		line.graphics.lineTo( x1, centerY );
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawPosLine:" + e.toString());
	}
}

//	+----------+
//	| 座標表示 |
//	+----------+
function drawPosText(text1,text2)
{
	var x = text1.text;
	var y = text2.text;
	text1.x = centerX + x * span - 4;
	if ( y >= 0 )
	{
		text1.y = centerY;
	}
	else
	{
		text1.y = centerY - 20;
	}
	if ( x >= 0 )
	{
		text2.textAlign = "right";
		text2.x = centerX - 4;
	}
	else
	{
		text2.textAlign = "left";
		text2.x = centerX + 4;
	}
	text2.y = centerY - y * span - 10;
}

//	+------------+
//	| 座標表示２ |
//	+------------+
function drawPosText2(text1,text2)
{
	var x = text1.text;
	var y = text2.text;
	if ( x >= 0 )
	{
		text1.x = centerX + x * span + 4;
	}
	else
	{
		text1.x = centerX + x * span - 18;
	}
	text1.y = centerY;
	
	text2.textAlign = "right";
	text2.x = centerX - 4;
	if ( y >= 0 )
	{
		text2.y = centerY - y * span - 20;
	}
	else
	{
		text2.y = centerY - y * span;
	}
}

//	+--------------+
//	| 計算処理サブ |
//	+--------------+
function calcLine(x1,y1,x2,y2)
{
	
	var a = ( x2-x1 ) / ( y2-y1 );
	var b = 1;
	var c = y2;
	return [ {a:a,b:b,c:c} ];
}

// ２直線の交点
function calcCrossPoint(a0,b0,c0,a1,b1,c1)
{
	var a = a0 / b0;
	var b = c0 / b0;
	var c = a1 / b1;
	var d = c1 / b1;
	var x = ( d - b ) / ( a - c );
	var y = -( a * d - b * c ) / ( a - c );
	x = Math.round( x * 100 ) / 100;
	y = Math.round( y * 100 ) / 100;
	return [ { x:x, y:y } ];
}

// 円と直線の交点
function cli(a,b,c,x1,y1,r)
{
	var l = a*a+b*b;
	var k = a*x1+b*y1+c;
	var d = l*r*r-k*k;
	if(d>0){
		var ds = Math.sqrt(d);
		var apl = a/l;
		var bpl = b/l;
		var xc = x1-apl*k;
		var yc = y1-bpl*k;
		var xd = bpl*ds;
		var yd = apl*ds;
		return [
			{x:xc-xd,y:yc+yd},
			{x:xc+xd,y:yc-yd}
		];
	}else if(d==0){
		return [{x:x1-a*k/l,y:y1-b*k/l}];
	}else{
		return [];
	}
}
// 円と円の交点
function cci(x1,y1,r1,x2,y2,r2)
{
	var a = x1-x2;
	var b = y1-y2;
	return cli(a,b,0.5*((r1-r2)*(r1+r2)-a*(x1+x2)-b*(y1+y2)),x1,y1,r1);
}

// 円の半径
function calcRad(x,y,l,m,n)
{
	var xx = x + l / 2;
	var yy = y + m / 2;
	var rad = ( l * l + m * m ) / 4 + n;
	var r = Math.sqrt( rad );
	return	[ {x:xx,y:yy,rad:rad,r:r} ];
}

//	+----------+
//	| 値の入力 |
//	+----------+
function changeDataHandler(e)
{
	try
	{
		switch( e.currentTarget.id )
		{
			case "upBtn0":
				if(valX + stepSize < valX1)
				{
					valX += stepSize;
					valX = Math.round( valX * 100 ) / 100;
					document.getElementById('num0x').innerHTML = valX;
					document.getElementById('num0X').innerHTML = valX;
				}
				break;
			case "downBtn0":
				valX -= stepSize;
				valX = Math.round( valX * 100 ) / 100;
				document.getElementById('num0x').innerHTML = valX;
				document.getElementById('num0X').innerHTML = valX;
				break;
				
			case "upBtn1":
				valX1 += stepSize;
				valX1 = Math.round( valX1 * 100 ) / 100;
				document.getElementById('num1x').innerHTML = valX1;
				document.getElementById('num1X').innerHTML = valX1;
				break;
			case "downBtn1":
				if(valX1 - stepSize > valX)
				{
					valX1 -= stepSize;
					valX1 = Math.round( valX1 * 100 ) / 100;
					document.getElementById('num1x').innerHTML = valX1;
					document.getElementById('num1X').innerHTML = valX1;
				}
				break;
		}
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

// +----------------------------+
// | 式の値変更入力画面オープン |
// +----------------------------+
function openOptionHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			//式の値を設定
			document.getElementById('text0_0').value = aNum;
			document.getElementById('text0_1').value = bNum;
			document.getElementById('text0_2').value = cNum;
			showModal('optionBlock');
		}
	}
	catch(e)
	{
		alert('openOptionHandler:' + e.toString());
	}
}

// +----------------+
// | 式の値変更入力 |
// +----------------+
function changeFormulaHandler(e)
{
	try
	{
		var num;
		switch(e.target.id)
		{
			case "upBtn0_0":
				num = parseFloat(document.getElementById("text0_0").value);
				num += stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_0").value = num;
				break;
			case "upBtn0_1":
				num = parseFloat(document.getElementById("text0_1").value);
				num += stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_1").value = num;
				break;
			case "upBtn0_2":
				num = parseFloat(document.getElementById("text0_2").value);
				num += stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_2").value = num;
				break;
			
			case "downBtn0_0":
				num = parseFloat(document.getElementById("text0_0").value);
				num -= stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_0").value = num;
				break;
			case "downBtn0_1":
				num = parseFloat(document.getElementById("text0_1").value);
				num -= stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_1").value = num;
				break;
			case "downBtn0_2":
				num = parseFloat(document.getElementById("text0_2").value);
				num -= stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_2").value = num;
				break;
		}
	}
	catch(e)
	{
		alert("changeFormulaHandler:" + e.toString());
	}
}

// +----------------------------+
// | 式の値変更入力画面クローズ |
// +----------------------------+
function closeOptionHandler(e)
{
	try
	{
		aNum = parseFloat(document.getElementById("text0_0").value);
		bNum = parseFloat(document.getElementById("text0_1").value);
		cNum = parseFloat(document.getElementById("text0_2").value);
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		closeModal();
	}
	catch(e)
	{
		alert("closeOptionHandler:" + e.toString());
	}
}

//	+------------------------------+
//	| チェックボックスのオン・オフ |
//	+------------------------------+
function changeCheckHandler(e)
{
	try
	{
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}


//	+------------------------+
//	| 隠しボタンのオン・オフ |
//	+------------------------+
function changeHidenBtnHandler(e)
{
	try
	{
		switch(e.currentTarget.id)
		{
			case "hidenBtn0":
				if ( document.getElementById("form1").style.display == "none" )
				{
					document.getElementById("form1").style.display = "";
					document.getElementById("form3").style.display = "";
				}
				else
				{
					document.getElementById("form1").style.display = "none";
					document.getElementById("form3").style.display = "none";
				}
				break;
			case "hidenBtn1":
				if ( document.getElementById("form2").style.display == "none" )
				{
					document.getElementById("form2").style.display = "";
					document.getElementById("form4").style.display = "";
				}
				else
				{
					document.getElementById("form2").style.display = "none";
					document.getElementById("form4").style.display = "none";
				}
				break;
			case "hidenBtnL":
				if( document.getElementById("formL").style.display == "none")
				{
					document.getElementById("formL").style.display = "";
				}
				else
				{
					document.getElementById("formL").style.display = "none";
				}
				break;
				
			case "hidenBtnM":
				if( document.getElementById("formM").style.display == "none")
				{
					document.getElementById("formM").style.display = "";
				}
				else
				{
					document.getElementById("formM").style.display = "none";
				}
				break;
		}
		drawFormula();
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

//	+----------------------+
//	| 刻み幅の設定画面表示 |
//	+----------------------+
function openMenuBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		if ( e.currentTarget.id == "stepText" )
		{
			inner = [0.1, 0.2, 0.5, 1, 2, 5, 10];
			data = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		}
		openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeStepSize);
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}
//	+--------------+
//	| 刻み幅の変更 |
//	+--------------+
function changeStepSize(id, num)
{
	try
	{
		stepSize = num;
		var n;
		
		// 設定した刻み幅の倍数に変更
		n   = Math.round(p1x/num) * num;
		p1x = Math.round(n * 100)/100;
		n   = Math.round(p1y/num) * num;
		p1y = Math.round(n * 100)/100;
		n   = Math.round(p2x/num) * num;
		p2x = Math.round(n * 100)/100;
		n   = Math.round(p2y/num) * num;
		p2y = Math.round(n * 100)/100;
		n   = Math.round(px/num) * num;
		px  = Math.round(n * 100)/100;
		n   = Math.round(py/num) * num;
		py  = Math.round(n * 100)/100;
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeStepSize:" + e.toString());
	}
}

//	+------------------+
//	| 点のドラッグ開始 |
//	+------------------+
function dotDragStart(e)
{
	try
	{
		if ( dFlag )
		{
			dFlag = false;
			prevX = e.stageX;
			prevY = e.stageY;
			dotNum = 0;
			if ( e.currentTarget.name == "DOT_1" )	{	dotNum = 1;		}
			if ( e.currentTarget.name == "DOT_2" )	{	dotNum = 2;		}
			
			e.currentTarget.addEventListener("pressmove", dotDragMove);
			e.currentTarget.addEventListener("pressup", dotDragStop);
			e.currentTarget.addEventListener("mouseup", dotDragStop);
			e.currentTarget.addEventListener("mouseout", dotDragStop);
		}
	}
	catch(e)
	{
		alert("dotDragStart:" + e.toString());
	}
}

//	+--------------+
//	| 点のドラッグ |
//	+--------------+
function dotDragMove(e)
{
	try
	{
		var x = e.stageX - prevX;
		var y = e.stageY - prevY;
		var size = 0.1;
		
		if ( Math.abs( x ) > 1 || Math.abs( y ) > 1 )
		{
			prevX = e.stageX;
			prevY = e.stageY;
			var numX = ( e.stageX - centerX ) / span;
			var numY = -( e.stageY - centerY ) / span;
			numX = Math.round( numX / size ) * size;
			numY = Math.round( numY / size ) * size;
			numX = Math.round( numX * 10 ) / 10;
			numY = Math.round( numY * 10 ) / 10;
			switch ( dotNum )
			{
				case 1:
					if(numX < valX1)
					{
						valX = numX;
						valY = func_X(valX);
						// 値表示
						document.getElementById("num0x").innerHTML = Math.round(valX*100)/100;
						document.getElementById("num0y").innerHTML = Math.round(valY*100)/100;
						document.getElementById("num0X").innerHTML = Math.round(valX*100)/100;
					}
					break;
				case 2:
					if(numX > valX)
					{
						valX1 = numX;
						valY1 = func_X(valX1);
						// 値表示
						document.getElementById("num1x").innerHTML = Math.round(valX1*100)/100;
						document.getElementById("num1y").innerHTML = Math.round(valY1*100)/100;
						document.getElementById("num1X").innerHTML = Math.round(valX1*100)/100;
					}
					break;
			}
		}
		calcData();
		//drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("dotDragMove:" + e.toString());
	}
}

//	+------------------+
//	| 点のドラッグ終了 |
//	+------------------+
function dotDragStop(e)
{
	try
	{
		dFlag = true;
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		
		e.currentTarget.removeEventListener("pressmove", dotDragMove);
		e.currentTarget.removeEventListener("pressup", dotDragMove);
		e.currentTarget.removeEventListener("mouseup", dotDragMove);
		e.currentTarget.removeEventListener("mouseout", dotDragMove);
	}
	catch(e)
	{
		alert("dotDragStop:" + e.toString());
	}
}

//	+------------------+
//	| 円のドラッグ開始 |
//	+------------------+
/*----------------------------------------------------------------------------------------------------------------------
function lineDragStart(e)
{
	try
	{
		if ( dFlag )
		{
			dFlag = false;
			prevX = e.stageX;
			prevY = e.stageY;
			
			cs.update();
			e.currentTarget.addEventListener("pressmove", lineDragMove);
			e.currentTarget.addEventListener("pressup",lineDragStop);
			e.currentTarget.addEventListener("mouseup", lineDragStop);
			e.currentTarget.addEventListener("mouseout", lineDragStop);
		}
	}
	catch(e)
	{
		alert("lineDragStart:" + e.toString());
	}
}
*/

//	+--------------+
//	| 円のドラッグ |
//	+--------------+
/*----------------------------------------------------------------------------------------------------------------------
function lineDragMove(e)
{
	try
	{
		var x = e.stageX - prevX;
		var y = e.stageY - prevY;
		var size = 0.01;
		
		
		
	}
	catch(e)
	{
		alert("lineDragMove:" + e.toString());
	}
}
*/
//	+------------------+
//	| 円のドラッグ終了 |
//	+------------------+
/*----------------------------------------------------------------------------------------------------------------------
function lineDragStop(e)
{
	try
	{
	
	
	
		e.currentTarget.removeEventListener("pressmove", dotDragMove);
		e.currentTarget.removeEventListener("pressup", dotDragMove);
		e.currentTarget.removeEventListener("mouseup", dotDragMove);
		e.currentTarget.removeEventListener("mouseout", dotDragMove);
	}
	catch(e)
	{
		alert("lineDragStop:" + e.toString());
	}
}
*/

//	+--------------------------+
//	| キャンバスのドラッグ開始 |
//	+--------------------------+
function canvasDragStart(e)
{
	if(dFlag)
	{
		prevX = e.stageX;
		prevY = e.stageY;
		
		if(ictMode)
		{
			$(window).on("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchend', dragStop);
		}
		else
		{
			document.addEventListener('mouseup', dragStop);
		}
		
		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

//	+----------------------+
//	| キャンバスのドラッグ |
//	+----------------------+
function canvasDragMove(e)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		//座標の変化量
		var sX;
		var sY;
		
		if(cScale >= 1)
		{
			sX = e.stageX - prevX;
			sY = e.stageY - prevY;
		}
		else
		{
			sX = (e.stageX - prevX) * cScale;
			sY = (e.stageY - prevY) * cScale;
		}
		
		//移動限界
		var limitX = cW * 1/3 - cW * cScale;
		var limitY = cH * 1/3 - cH * cScale;
		
		//Xの差分移動
		if(p.left + sX >= 0)
		{
			document.getElementById("graphCanvas").style.left = "0px";
			
			prevX = e.stageX;
		}
		else if(p.left + sX <= limitX)
		{
			document.getElementById("graphCanvas").style.left = limitX + "px";
			
			prevX = e.stageX;
		}
		else
		{
			document.getElementById("graphCanvas").style.left = (p.left + sX) + "px";
		}
		
		//Yの差分移動
		if(p.top + sY >= 0)
		{
			document.getElementById("graphCanvas").style.top = "0px";
			
			prevY = e.stageY;
		}
		else if(p.top + sY <= limitY)
		{
			document.getElementById("graphCanvas").style.top = limitY + "px";
			
			prevY = e.stageY;
		}
		else
		{
			document.getElementById("graphCanvas").style.top = (p.top + sY) + "px";
		}
		
		changeAxisPositionHandler();
		changeGraphScale(configArray[1][0], configArray[1][1]);
		cs.update();
	}
	catch(e)
	{
		alert("canvasDragMove:" + e.toString());
	}
	
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function canvasDragStop(e)
{
	e.currentTarget.removeEventListener("pressmove", canvasDragMove);
	e.currentTarget.removeEventListener("pressup", canvasDragStop);
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function dragStop(e)
{
	try
	{
		if(ictMode)
		{
			$(window).off("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchend', dragStop);
		}
		else
		{
			document.removeEventListener('mouseup', dragStop);
		}
	}
	catch(e)
	{
		alert(e.toString());	
	}
}

//	+----------------------------+
//	| オプション画面のスクロール |
//	+----------------------------+
function closeInnerBalloonHandler(e)
{
	try
	{
		// 刻み幅入力画面が開かれていたら閉じる
		if ( document.getElementById("selectBalloon_menu").style.display != "none" )
		{
			closeSelectBalloon();
		}
	}
	catch(e)
	{
		alert("closeInnerBalloonHandler:" + e.toString());
	}
}

//	+--------------+
//	| スケール変更 |
//	+--------------+
function changeGraphScale(sX, sY)
{
	try
	{
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		
		//y軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の目盛
		if(sX != null)
		{
			var spanX = span * sX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
		}
		
		
		//y軸の目盛
		if(sY != null)
		{
			spanY = span * sY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
		}
	}
	catch(e)
	{
		alert("changeGraphScale:" + e.toString());
	}
}

//	+--------------+
//	| グリッド変更 |
//	+--------------+
function changeGraphGrid(gX, gY)
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の線
		if(gX != null)
		{
			var spanX = span * gX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
		}
		
		
		//y軸の線
		if(gY != null)
		{
			spanY = span * gY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
		}
	}
	catch(e)
	{
		alert('changeGraphGrid:' + e.toString());
	}
}

//	+----------------+
//	| グラフ目盛作成 |
//	+----------------+
function createPointText(str)
{
	try
	{
		var c = new createjs.Container();
		
		if(str != "")
		{
			changePointText(c, str);
		}
		
		return c;
	}
	catch(e)
	{
		alert("createPointText:" + e.toString());
	}
}

//	+----------------+
//	| グラフ目盛変更 |
//	+----------------+
function changePointText(c, str)
{
	try
	{
		//削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		//弧度法
		if(str.indexOf("π") != -1)
		{
			//頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				var t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
				
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str, "16px Times New Roman", "#000000");
					c.addChild(t0_5);
				}
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("changePointText:" + str + "-" + e.toString());
	}
}

// +----------+
// | 状態保存 |
// +----------+
function saveContent()
{
	try
	{
		var array = [];
		
		// 刻み値
		array[0] = stepSize;
		
		//設定吹き出し
		array[1] = configArray.slice();
		
		// 変数
		array[2] = [ { x:valX, y:valY, x1:valX1, y1:valY1, px:valPX, py:valPY }, { a:aNum, b:bNum, c:cNum } ];
		
		// 画面項目
		var chk0 = document.getElementById("check0").checked;
		var chk1 = document.getElementById("check1").checked;
		var chk2 = document.getElementById("check2").checked;
		var chkL = document.getElementById("checkL").checked;
		var chkM = document.getElementById("checkM").checked;
		var chkP = document.getElementById("checkP").checked;
		var chk3 = document.getElementById("check3").checked;
		var chk4 = document.getElementById("check4").checked;
		array[3] = [ { 
						chk0:chk0, 
						chk1:chk1, 
						chk2:chk2, 
						chkL:chkL, 
						chkM:chkM,
						chkP:chkP,
						chk3:chk3,
						chk4:chk4,
					} ];
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

// +----------+
// | 状態読込 |
// +----------+
function loadContent(array)
{
	try
	{
		// 刻み値
		stepSize = array[0];
		//document.getElementById("stepText").innerHTML = stepSize;
		
		//設定吹き出し
		configArray = array[1].slice();
		
		// 変数
		valX = array[2][0].x;
		valY = array[2][0].y;
		valX1 = array[2][0].x1;
		valY1 = array[2][0].y1;
		valPX = array[2][0].px;
		valPY = array[2][0].py;
		aNum = array[2][1].a;
		bNum = array[2][1].b;
		cNum = array[2][1].c;
		
		// 画面項目
		document.getElementById("check0").checked = array[3][0].chk0;
		document.getElementById("check1").checked = array[3][0].chk1;
		document.getElementById("check2").checked = array[3][0].chk2;
		document.getElementById("checkL").checked = array[3][0].chkL;
		document.getElementById("checkM").checked = array[3][0].chkM;
		document.getElementById("checkP").checked = array[3][0].chkP;
		document.getElementById("check3").checked = array[3][0].chk3;
		document.getElementById("check4").checked = array[3][0].chk4;
		
		// グラフ
		changeGraphScale(null, null);
		changeGraphGrid(null, null);
		
		// 画面表示
		//document.getElementById("num0X").innerHTML = Math.round(valX*100)/100;
		//document.getElementById("num1X").innerHTML = Math.round(valY*100)/100;
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

// +----------+
// | リセット |
// +----------+
function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			// 刻み値
			stepSize = 1;
			
			//設定吹き出し
			configArray = [];
			configArray[0] = [-30, 360, -10, 10];
			configArray[1] = [null, null];
			configArray[2] = [null, null];
			
			// 値の上限、下限、既定値
			defMin = -10;
			defMax = 10;
			defNum = 0;
			
			valX  = -1;
			valY  = 1;
			valX1 = 3;
			valY1 = 9;
			valPX = 0;
			valPY = 0;
			aNum  = 1;
			bNum  = 0;
			cNum  = 0;
			
			// ドラッグ関連
			dFlag = true;
			animeFlag = false;
			
			// 状態の記録エリア
			recData = [];
			
			// チェックボックス
			document.getElementById("check0").checked = true;
			document.getElementById("check1").checked = true;
			document.getElementById("check2").checked = true;
			document.getElementById("checkL").checked = true;
			document.getElementById("checkM").checked = true;
			document.getElementById("checkP").checked = false;
			document.getElementById("check3").checked = false;
			document.getElementById("check4").checked = false;
			document.getElementById("form1").style.display = "none";
			document.getElementById("form2").style.display = "none";
			document.getElementById("form3").style.display = "none";
			document.getElementById("form4").style.display = "none";
			document.getElementById("formL").style.display = "none";
			document.getElementById("formM").style.display = "none";
			
			
			
			// ドラッグ関連
			dFlag = true;
			
			// 初期表示に戻す
			changeGraphScale(null, null);
			changeGraphGrid(null, null);
			
			// 刻み幅
//			document.getElementById("stepText").innerHTML = stepSize;
			
			// 値表示
			document.getElementById("num0x").innerHTML = valX;
			document.getElementById("num0y").innerHTML = valY;
			document.getElementById("num1x").innerHTML = valX1;
			document.getElementById("num1y").innerHTML = valY1;
			document.getElementById("num0X").innerHTML = valX;
			document.getElementById("num1X").innerHTML = valX1;
			
			// 軸表示
			drawBaseLine();
			changeAxisPositionHandler();
			
			// 計算処理
			calcData();
			
			// 式の表示
			drawFormula();
			
			// 図形の表示
			drawShape();
			
			// テキストの表示
			drawText();
		
			// オプションメニュー画面
			setModal('optionBlock');
			setModal('spanChange');
			setMenuMode(0, 320);
			$("#controlBlock").css("overflow-x", "hidden");		// 横スクロールバーは非表示
			
			// ステージ更新
			cs.update();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
S