// JavaScript Document
/*使用するイベントハンドラではthisがイベント登録対象になるのでAnimeSliderであるthisを変数で格納*/

var animeSlider;
var animeTimer;

AnimeSlider = function(min, max, def, w, h, changeFnc, captureFnc, removeFnc)
{
	try
	{
		if(!(this instanceof AnimeSlider)) 
		{
        	return new AnimeSlider(min, max, def, w, h, changeFnc, captureFnc, removeFnc);
    	}
		
		this.min;
		this.max;
		
		this.def;
		this.prev;
		
		this.changeNumber = document.getElementById("changeNumber");
		
		//変更時に呼び出す関数
		this.changeFnc = changeFnc;
		
		//キャプチャ時に呼び出す関数
		this.captureFnc = captureFnc;
		
		//キャプチャ削除時に呼び出す関数
		this.removeFnc = removeFnc;
		
		this.sc = document.getElementById("sliderCanvas");
		this.ss = new createjs.Stage(this.sc);
		
		this.scW  = w;
		this.scH = h;
		
		this.sc.width = w;
		this.sc.height = h;
		
		this.pointSpan;
		
		this.marginTB = 5;
		this.marginLR = 10;
		
		this.spanArray = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		
		this.speedArray = [0.2, 0.5, 1, 2, 5];
		this.speedIndex = 2;
		
		this.loopMode = 0;
		this.loopFlag = true;
		
		this.sLine = new createjs.Shape();
		this.ss.addChild(this.sLine);
		
		this.sPoint = new createjs.Shape();
		this.sPoint.graphics.setStrokeStyle(0);
		this.sPoint.graphics.beginStroke("#0095DF");
		this.sPoint.graphics.beginFill("#0095DF");
		this.sPoint.graphics.drawCircle(0, 0, 5);
		this.sPoint.graphics.endFill();
		this.sPoint.graphics.endStroke();
		this.ss.addChild(this.sPoint);
		
		//最小・最大変更
		document.getElementById("slMin").addEventListener("click", changeLimitHandler);
		
		document.getElementById("srMin").addEventListener("click", changeLimitHandler);
		document.getElementById("slMax").addEventListener("click", changeLimitHandler);
		document.getElementById("srMax").addEventListener("click", changeLimitHandler);
		
		//ループ
		document.getElementById("loopBtn").addEventListener("click", changeLoopHandler);
		
		
		//再生
		document.getElementById("playBtn").addEventListener("click", playAnimationHandler);
		
		//位置移動
		document.getElementById('nextPoint').addEventListener("click", changePointHandler);
		document.getElementById('backPoint').addEventListener("click", changePointHandler);
		document.getElementById('firstPoint').addEventListener("click", changePointHandler);
		document.getElementById('lastPoint').addEventListener("click", changePointHandler);
		
		//速度
		document.getElementById("speedConfig").addEventListener("click", changeSpeedHandler);
		
		//キャプチャ
		document.getElementById("captureBtn").addEventListener("click", captureHandler);
		
		//削除
		document.getElementById("removeBtn").addEventListener("click", removeDataHandler);
		
		animeSlider = this;
		
		/*値を設定*/
		this.setSliderData(min, max, def, def);
	}
	catch(e)
	{
		alert("AnimeSlider setAnimeSlider:" + e.toString());
	}
};

AnimeSlider.prototype.setSliderData = function(min, max, def, prev)
{
	try
	{
		this.min = min;
		this.max = max;
		this.def = def;
		this.prev = prev;
		
		document.getElementById("tMin").innerHTML = min;
		document.getElementById("tMax").innerHTML = max;
		
		this.changeSliderLine();
	}
	catch(e)
	{
		alert("setSliderData:" + e.toString());
	}
}

function changeLimitHandler(e)
{
	try
	{

		if(animeFlag == false)
		{
			var f = false;

			//最小値の変更
			if(e.target.id.indexOf("Min") != -1)
			{
				if(e.target.id == "slMin")
				{
					animeSlider.min--;
					f = true;
				}
				else if(e.target.id == "srMin" && animeSlider.min+1 < animeSlider.max)
				{
					animeSlider.min++;
					f = true;
				}

				document.getElementById("tMin").innerHTML = animeSlider.min;
			}
			else
			{
				if(e.target.id == "srMax")
				{
					animeSlider.max++;
					f = true;
				}
				else if(e.target.id == "slMax" && animeSlider.max-1 > animeSlider.min)
				{
					animeSlider.max--;
					f = true;
				}

				document.getElementById("tMax").innerHTML = animeSlider.max;
			}


			if(f)
			{
				var f1 = false;
				if(animeSlider.prev < animeSlider.min)
				{
					animeSlider.prev = animeSlider.min;
					f1 = true;
				}
				else if(animeSlider.prev > animeSlider.max)
				{
					animeSlider.prev = animeSlider.max;
					f1 = true;
				}

				if(f1)
				{
					animeSlider.changeFnc();
				}

				//スライダの状態を変更
				animeSlider.changeSliderLine();
			}
		}
	}
	catch(e)
	{
		alert("AnimeSlider changeLimitHandler:" + e.toString());
	}
}

function changeSpeedHandler(e)
{
	try
	{
			if(animeSlider.speedIndex+1 < animeSlider.speedArray.length)
			{
				animeSlider.speedIndex++;
			}
			else
			{
				animeSlider.speedIndex = 0;
			}

			document.getElementById("speedConfig").src = "./img/s" +animeSlider.speedArray[animeSlider.speedIndex] + ".png";
	}
	catch(e)
	{
		alert("AnimeSlider changeSpeedHandler:" + e.toString());
	}
}

AnimeSlider.prototype.changeSliderLine = function()
{
	try
	{
		this.sLine.graphics.clear();
		
		this.sLine.graphics.setStrokeStyle(2);
		this.sLine.graphics.beginStroke("#000000");
		this.sLine.graphics.moveTo(this.marginLR, this.scH/2);
		this.sLine.graphics.lineTo(this.scW-this.marginLR, this.scH/2);
		
		var cnt = this.max - this.min;
		
		var i;
		this.pointSpan = (this.scW-this.marginLR*2)/cnt;
		
		for(i=0; i<=cnt; i++)
		{
			if(i==0 || i==cnt || i+this.min == 0)
			{
				this.sLine.graphics.moveTo(this.marginLR+i * this.pointSpan, this.scH/2-this.marginTB*2);
				this.sLine.graphics.lineTo(this.marginLR+i * this.pointSpan, this.scH/2+this.marginTB*2);
			}
			else
			{
				this.sLine.graphics.moveTo(this.marginLR+i * this.pointSpan, this.scH/2-this.marginTB);
				this.sLine.graphics.lineTo(this.marginLR+i * this.pointSpan, this.scH/2+this.marginTB);
			}
		}
		
		this.sLine.graphics.endStroke();
		
		this.sPoint.y = this.scH/2;
		
		if(this.def >= this.min && this.def <= this.max)
		{
			this.sPoint.x = this.marginLR + (this.def - this.min) * this.pointSpan;
			this.prev = this.def;
		}
		else if(this.def < this.min)
		{
			this.sPoint.x = this.marginLR;
			this.prev = this.min;
		}
		else
		{
			this.sPoint.x = this.marginLR - this.pointSpan * cnt;
			this.prev = this.max;
		}
		
		this.changeSliderControl();
		
		this.changeNumber.innerHTML = this.prev;
		
		this.ss.update();
	}
	catch(e)
	{
		alert("AnimeSlider changeSliderLine:" + e.toString());
	}
};


AnimeSlider.prototype.changeSliderControl = function()
{
	try
	{
		if(this.prev == this.min)
		{
			document.getElementById("backPoint").src = "./img/backOff.png";
			document.getElementById("firstPoint").src = "./img/firstOff.png";
		}
		else
		{
			document.getElementById("backPoint").src = "./img/backOn.png";
			document.getElementById("firstPoint").src = "./img/firstOn.png";
		}

		if(this.prev == this.max)
		{
			document.getElementById("nextPoint").src = "./img/nextOff.png";
			document.getElementById("lastPoint").src = "./img/lastOff.png";
		}
		else
		{
			document.getElementById("nextPoint").src = "./img/nextOn.png";
			document.getElementById("lastPoint").src = "./img/lastOn.png";
		}
	}
	catch(e)
	{
		alert("AnimeSlider changeSliderControl:" + e.toString());
	}
};


AnimeSlider.prototype.changeSliderPoint = function()
{
	try
	{
		this.sPoint.y = this.scH/2;
		
		this.sPoint.x = this.marginLR + (this.prev - this.min) * this.pointSpan;
	}
	catch(e)
	{
		alert("AnimeSlider changeSliderPoint:" + e.toString());
	}
};


function playAnimationHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			document.getElementById("playBtn").src = "./img/stopIcon.png";

			startAnimation();
		}
		else
		{
			clearTimeout(animeTimer);
			document.getElementById("playBtn").src = "./img/playIcon.png";
		}

		animeFlag = !animeFlag;
	}
	catch(e)
	{
		alert("AnimeSlider playAnimationHandler:" + e.toString());
	}
};

function startAnimation()
{
	try
	{
		
		//　1/5秒ごとに表示変更
		var sec = 200;
		animeTimer = setTimeout(stopAnimation, sec);
	}
	catch(e)
	{
		alert("startAnimation:" + e.toString());
	}
};

function stopAnimation()
{
	try
	{
		clearTimeout(animeTimer);
		
		//スライド全体でのデフォルト(1x)でのミリ秒数
		var d = 10000;
		var s = 200;
		
		//全体のかかる時間
		d = d / animeSlider.speedArray[animeSlider.speedIndex];
		
		var sub = (animeSlider.max-animeSlider.min) * s/d;
		
		if(animeSlider.loopMode != 0 || animeSlider.loopFlag)
		{
			animeSlider.prev = Math.round((animeSlider.prev + sub)*100)/100;
			
			if(animeSlider.prev >= animeSlider.max)
			{
				animeSlider.prev = animeSlider.max;
			}
		}
		else
		{
			animeSlider.prev = Math.round((animeSlider.prev - sub)*100)/100;
			
			if(animeSlider.prev <= animeSlider.min)
			{
				animeSlider.prev = animeSlider.min;
			}
		}
		
		animeSlider.sPoint.x = animeSlider.marginLR + (animeSlider.prev-animeSlider.min) * animeSlider.pointSpan;
		
		animeSlider.changeNumber.innerHTML = animeSlider.prev;
			
		animeSlider.changeSliderControl();
		
		animeSlider.ss.update();
		
		animeSlider.changeFnc();
		
		//繰り返し
		if(animeSlider.loopMode == 0)
		{
			//順行
			if(animeSlider.loopFlag == true)
			{
				if(animeSlider.prev >= animeSlider.max)
				{
					animeSlider.loopFlag = false;
				}
			}
			//逆行
			else
			{
				if(animeSlider.prev <= animeSlider.min)
				{
					animeSlider.loopFlag = true;
				}
			}
			
			startAnimation();
		}
		else if(animeSlider.loopMode == 1)
		{
			if(animeSlider.prev >= animeSlider.max)
			{
				animeSlider.prev = animeSlider.min;
			}

			startAnimation();
		}
		else
		{
			if(animeSlider.prev < animeSlider.max)
			{
				startAnimation();
			}
			else
			{
				//アニメーション終了
				document.getElementById("playBtn").src = "./img/playIcon.png";
				animeFlag = false;
			}
		}
	}
	catch(e)
	{
		alert("AnimeSlider stopAnimation:" + e.toString());
	}
};

function changeLoopHandler(e)
{
	try
	{
		switch(animeSlider.loopMode)
		{
			case 0:
				animeSlider.loopMode = 1;
				animeSlider.loopFlag = false;
				document.getElementById("loopBtn").src = "./img/autoIcon.png";
				break;

			case 1:
				animeSlider.loopMode = 2;
				animeSlider.document.getElementById("loopBtn").src = "./img/normalIcon.png";
				break;

			case 2:
				animeSlider.loopMode = 0;
				animeSlider.loopFlag = false;
				document.getElementById("loopBtn").src = "./img/loopIcon.png";
				break;
		}
	}
	catch(e)
	{
		alert("AnimeSlider changeLoopHandler:" + e.toString());
	}
}

function changePointHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			var f = false;
			if(e.target.id == "backPoint" && animeSlider.prev-1 >= animeSlider.min)
			{
				animeSlider.prev = Math.floor(animeSlider.prev)-1;

				f = true;
			}
			else if(e.target.id == "nextPoint" && animeSlider.prev+1 <= animeSlider.max)
			{
				animeSlider.prev = Math.floor(animeSlider.prev)+1;
				f = true;
			}
			else if(e.target.id == "firstPoint" && animeSlider.prev > animeSlider.min)
			{
				animeSlider.prev = animeSlider.min;
				f = true;
			}
			else if(e.target.id == "lastPoint" && animeSlider.prev < animeSlider.max)
			{
				animeSlider.prev = animeSlider.max;
				f = true;
			}

			if(f)
			{
				animeSlider.changeFnc();


				animeSlider.changeSliderPoint();
				animeSlider.changeSliderControl();

				animeSlider.changeNumber.innerHTML = animeSlider.prev;

				animeSlider.ss.update();
			}
		}
	}
	catch(e)
	{
		alert("AnimeSlider changePointHandler:" + e.toString());
	}
}

function captureHandler(e)
{
	animeSlider.captureFnc();	
}

function removeDataHandler(e)
{
	animeSlider.removeFnc();
}


