// JavaScript Document
var formArray;
var prevArray;

var formDataArray;

function initDropBalloon(n0, n1, n2, n3, n4)
{
	try
	{
		//数式の状態
		formArray = [n0, n1, n2, n3, n4];
		
		formDataArray = [];
		
		//三角関数
		formDataArray[0] = ["\\sin", "\\cos", "\\tan"];

		//加える角度
		formDataArray[1] = [0, 30, 45, 60, 90, 120, 135, 150, 180, 210, 225, 240, 270, 300, 315, 330, 360];

		//右辺の値
		formDataArray[2] = ["\\frac{1}{2}", "\\frac{1}{\\sqrt{3}}", "\\frac{1}{\\sqrt{2}}", "\\frac{\\sqrt{3}}{2}", "1", "\\sqrt{3}"];
		
		for(var i=0; i<=3; i++)
		{
			var j;
			
			switch(i)
			{
				//三角関数
				case 0:
					j=formDataArray[0].length;
					break;
				//θに足す数
				case 1:
					j=formDataArray[1].length;
					break;
				//右辺（弧度法）
				case 2:
					j=formDataArray[2].length;
					break;
				//右辺（度数法）
				case 3:
					j=formDataArray[2].length;
					break;
			}
			
			for(var k=0; k<j; k++)
			{
				document.getElementById("item"+i+"_"+k).addEventListener("click", selectItemHandler);
			}
		}
	}
	catch(e)
	{
		alert("initDropBalloon:" + e.toString());
	}
}

function setFormData()
{
	try
	{
		prevArray = formArray.slice();
		
		changeMathJax("fPart0", formDataArray[0][prevArray[0]]);
		
		if(prevArray[1])
		{
			changeMathJax("fPart1", "+");
		}
		else
		{
			changeMathJax("fPart1", "-");
		}
		
		var r;
		if($("#methodText").html() == "弧度法")
		{
			r = getRadiusTex(formDataArray[1][prevArray[2]], true);
		}
		else
		{
			r = getRadiusTex(formDataArray[1][prevArray[2]], false);
		}
		
		changeMathJax("fPart2", r);
		
		if(prevArray[3])
		{
			changeMathJax("fPart3", "+");
		}
		else
		{
			changeMathJax("fPart3", "-");
		}
		
		changeMathJax("fPart4", formDataArray[2][prevArray[4]]);
	}
	catch(e)
	{
		alert("setFormData:" + e.toString());
	}
}

function openDropBalloonHandler(e)
{
	try
	{
		var idStr = e.currentTarget.id;
		
		var f = false;
		
		//三角関数
		if(idStr == "fPart0")
		{
			if($("#dropBalloon").css("display") !="none" && $("#item0").css("display") == "block")
			{
				$("#dropBalloon").css("display", "none");
			}
			else
			{
				$("#item0").css("display", "block");
				$("#item1").css("display", "none");
				$("#item2").css("display", "none");
				$("#item3").css("display", "none");
				
				f = true;
			}
		}
		//加える値
		else if(idStr == "fPart2")
		{
			if($("#dropBalloon").css("display") !="none" && (($("#methodText").html() == "弧度法" && $("#item1").css("display") == "block") || ($("#methodText").html() == "弧度法" && $("#item1").css("display") == "block")))
			{
				$("#dropBalloon").css("display", "none");
			}
			else
			{
				$("#item0").css("display", "none");
				if($("#methodText").html() == "弧度法")
				{
					$("#item1").css("display", "block");
					$("#item2").css("display", "none");
				}
				else
				{
					$("#item1").css("display", "none");
					$("#item2").css("display", "block");
				}
				$("#item3").css("display", "none");
				
				f = true;
			}
		}
		//左辺の値
		else
		{
			if($("#dropBalloon").css("display") != "none" && $("#item3").css("display") == "block")
			{
				$("#dropBalloon").css("display", "none");
			}
			else
			{
				$("#item0").css("display", "none");
				$("#item1").css("display", "none");
				$("#item2").css("display", "none");
				$("#item3").css("display", "block");
				
				f = true;
			}
		}
		
		if(f)
		{
			$("#dropBalloon").css("display", "inline-block");
			
			var pX = $("#"+idStr).position().left;
			var pY = $("#"+idStr).position().top;
			var pW = $("#"+idStr).outerWidth();
			var pH = $("#"+idStr).outerHeight();
			
			$("#dropBalloon").css("left", pX + pW-60);
			$("#dropBalloon").css("top", pY+pH+20);
			
			document.getElementById("dropBalloonBlock").style.height = "auto";
			document.getElementById("dropBalloonBlock").style.overflow = "hidden";
			
			if($("#dropBalloon").innerHeight() > 200)
			{
				document.getElementById("dropBalloonBlock").style.height = "200px";
				document.getElementById("dropBalloonBlock").style.overflow = "scroll";
			}
		}
	}
	catch(e)
	{
		alert("openDropBalloonHandler:" + e.toString());
	}
}
//
function changeOperatorHandler(e)
{
	try
	{
		if(e.currentTarget.id == "fPart1")
		{
			if(prevArray[1])
			{
				changeMathJax("fPart1", "-");
			}
			else
			{
				changeMathJax("fPart1", "+");
			}
			
			prevArray[1]  = !prevArray[1];
		}
		else
		{
			if(prevArray[3])
			{
				changeMathJax("fPart3", "-");
			}
			else
			{
				changeMathJax("fPart3", "+");
			}
			
			prevArray[3]  = !prevArray[3];
		}
	}
	catch(e)
	{
		alert("changeOperatorHandler:" + e.toString());
	}
}

function selectItemHandler(e)
{
	try
	{
		str = e.currentTarget.id;
		
		var i = parseInt(str.substring(4, 5));
		var j = parseInt(str.substring(str.lastIndexOf("_")+1, str.length));
		
		//三角関数
		if(i==0)
		{
			changeMathJax("fPart0", formDataArray[0][j]);
			prevArray[0] = j;
		}
		//加える値
		else if(i==1)
		{
			var r;
			if($("#methodText").html() == "弧度法")
			{
				r = getRadiusTex(formDataArray[1][j], true);
			}
			else
			{
				r = getRadiusTex(formDataArray[1][j], false);
			}
			
			changeMathJax("fPart2", r);
			
			prevArray[2] = j;
		}
		//左辺の値
		else
		{
			changeMathJax("fPart4", formDataArray[2][j]);
			prevArray[4] = j;
		}
		
		$("#dropBalloon").css("display", "none");
	}
	catch(e)
	{
		alert("selectItemHandler:" + e.toString());
	}
}
