function changeFormulaStringContainer(c, str, array, s, skip, color)
{
	try
	{
		/*
		c：数式のコンテナ
		str：数式の文字列
		array ：斜体の対象となる文字を一文字ずつ格納する配列
		skip : 変換をスキップする際の区切り文字（文字で挟まれた部分は何もせずそのまま出力する）
		s：数式の文字サイズ
		color:色（指定がなければ黒にする）
		*/
		
		c.removeAllChildren();
		
		var w = 0;
		
		var splitArray = getSplitFormulaArray(str, array, skip);
		
		var cStr;
		
		if(color != null)
		{
			cStr = color;
		}
		else
		{
			cStr = "#000000";
		}
		
		var j = splitArray.length;
		for(var i=0; i<j; i++)
		{
			var t;
			//斜体文字の場合
			if(array.indexOf(splitArray[i]) != -1)
			{
				t = new createjs.Text(splitArray[i],  "Italic " + s + "px Times New Roman", cStr);
			}
			//立体文字の場合
			else
			{
				t = new createjs.Text(splitArray[i],  s + "px Times New Roman", cStr);
			}
			
			t.x = w;
			w += t.getBounds().width;
			c.addChild(t);
		}
		return w;
	}
	catch(e)
	{
		alert("changeFormulaStringContainer:" + e.toString());
	}
}


function getSplitFormulaArray(str, array, skip)
{
	try
	{
		var f = [];
		var add = "";
		var skipFlg = false;
		
		var j = str.length;
		for(var i=0; i<j; i++)
		{
			// スキップ文字ならフラグをセットして1文字飛ばす
			if ( str.substring(i,i+1) == skip )
			{
				skipFlg = !skipFlg;
				i++;
			}
			
			var k = str.substring(i,i+1);
			if ( skipFlg )
			{
				// 立体文字にしておく
				add+=k;
			}
			else
			{
				//斜体文字の場合
				if(array.indexOf(k) != -1)
				{
					if(add != "")
					{
						f.push(add);
						add="";
					}
					
					f.push(k);
				}
				//立体文字の場合
				else
				{
					add+=k;
				}
			}
		}
		
		if(add != "")
		{
			f.push(add);
		}
		
		return f;
	}
	catch(e)
	{
		alert("getSplitFormulaArray:" + e.toString());
	}
}