// JavaScript Document
var itemArray;
var scaleText;

function setGraphConfig(f)
{
	try
	{
		itemArray = [];
		
		itemArray[0] = [];
		itemArray[0][0]= ['なし', '刻み　1', '刻み　2', '刻み　5', '刻み　10'];
		itemArray[0][1] = [null, 1, 2, 5, 10];
		
		//目盛のテキスト
		scaleText = [];
		scaleText[0] = [null, true, []];
		scaleText[1] = [null, false, []];
		
		//クリックの設定
		//θ軸
		if(document.getElementById("graphModeText").innerHTML == "θ")
		{
			var frac0 = createFrac('<span class="times">π</span>', 6, "#000000");
			var frac1 = createFrac('<span class="times">π</span>', 4, "#000000");
			var frac2 = createFrac('<span class="times">π</span>', 3, "#000000");
			var frac3 = createFrac('<span class="times">π</span>', 2, "#000000");
			
			itemArray[1] = [];
			itemArray[1][0] = ['なし', '刻み　'+frac0, '刻み　'+frac1, '刻み　'+frac2, '刻み　'+frac3, '刻み　<span class="times">π</span>', '刻み　2<span class="times">π</span>'];
			
			itemArray[1][1] = ['なし', '刻み　30°', '刻み　45°', '刻み　60°', '刻み　90°', '刻み　180°', '刻み　360°'];
			itemArray[1][2] = [null, 30, 45, 60, 90, 180, 360];
		}
		
		document.getElementById("cTitle0").style.width = "200px";
		document.getElementById("cTitle1").style.width = "200px";
		
		document.getElementById("cItem1_0").addEventListener("click", openConfigBalloonHandler);
		document.getElementById("cItem1_1").addEventListener("click", openConfigBalloonHandler);
		document.getElementById("cItem2_0").addEventListener("click", openConfigBalloonHandler);
		document.getElementById("cItem2_1").addEventListener("click", openConfigBalloonHandler);
		
		//設定データのテキストを入れる
		changeMethodNumberHandler(f);
		
	}
	catch(e)
	{
		alert("setRadiusConfig:" + e.toString());
	}
}

function setConfigTableNumber(id, n, f)
{
	try
	{
		var elm = document.getElementById(id);
		
		if(n == null)
		{
			elm.innerHTML = "なし";
		}
		else
		{
			if(f)
			{
				var str0 = "刻み　";
				var str1;
				
				if(document.getElementById("methodText").innerHTML == "弧度法")
				{
					str1 = math.simplify(n+"/180").toString();
					str1 = getRadiusText(str1);
				}
				else
				{
					str1 = n + "°";
				}
				
				elm.innerHTML = str0 + str1;
			}
			else
			{
				elm.innerHTML = "刻み　" + n;
			}
		}
	}
	catch(e)
	{
		alert("setConfigTableNumber:" + e.toString());
	}
}


function changeMethodNumberHandler(f)
{
	try
	{
		if(document.getElementById("graphModeText").innerHTML == "θ")
		{
			setConfigTableNumber("cItem1_0", configArray[1][0], true);
			setConfigTableNumber("cItem1_1", configArray[1][1], false);
		}
		else
		{
			setConfigTableNumber("cItem1_0", configArray[1][0], true);
			setConfigTableNumber("cItem1_1", configArray[1][1], false);
		}
		
		setConfigTableNumber("cItem2_0", configArray[2][0], true);
		setConfigTableNumber("cItem2_1", configArray[2][1], false);
		
		//目盛の設定
		if(f == true)
		{
			changeGraphScale(Math.PI/2 * configArray[1][0]/180, configArray[1][1]);
			changeScaleText();
		}
	}
	catch(e)
	{
		alert("changeMethodNumberHandler:" + e.toString());
	}
}

function changeConfigAreaData(num, id, mode)
{
	try
	{
		var str;
		
		//
		switch(mode)
		{
			//そのままの数値
			case 0:
				str = num.toString();
				break;
			
			//弧度法
			case 1:
				str = math.simplify(num+"/180").toString();
				str = getRadiusText(str);
				break;
			
			//度数法
			case 2:
				str = num.toString() + "°";
				break;
		}
		
		document.getElementById(id).innerHTML = str;
	}
	catch(e)
	{
		alert("changeConfigAreaData:" + e.toString());
	}
}

function getRadiusText(str)
{
	try
	{
		//分数の場合
		if(str.indexOf("/") != -1)
		{
			var n = parseInt(str.substring(0, str.indexOf("/"))).toString();
			var d = parseInt(str.substring(str.indexOf("/")+1, str.length)).toString();
			
			if(n == 1)
			{
				str = createFrac('<span class="times">π</span>', d, "#007AC5").toString();
			}
			else if(n == -1)
			{
				str = createFrac('<span class="times">-π</span>', d, "#007AC5").toString();
			}
			else
			{
				str = createFrac(n+'<span class="times">π</span>', d, "#007AC5").toString();
			}
		}
		else
		{
			if(str == "1")
			{
				str = '<span class="times">π</span>';
			}
			else if(str == "-1")
			{
				str = '-<span class="times">π</span>';
			}
			else if(str != "0")
			{
				str = str + '<span class="times">π</span>';
			}
		}
		
		return str;
	}
	catch(e)
	{
		alert("getRadiusText:" + e.toString());
	}
}

function openConfigBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		
		//目盛 x軸　or θ軸
		if(e.currentTarget.id == "cItem1_0")
		{
			if(document.getElementById("graphModeText").innerHTML == "θ")
			{
				//弧度法
				if(document.getElementById("methodText").innerHTML == "弧度法")
				{
					inner = itemArray[1][0].slice();
					data = itemArray[1][2].slice();
				}
				//度数法
				else
				{
					inner = itemArray[1][1].slice();
					data = itemArray[1][2].slice();
				}
			}
			else
			{
				inner = itemArray[0][0].slice();
				data = itemArray[0][1].slice();
			}
		}
		//目盛 y軸
		else if(e.currentTarget.id == "cItem1_1")
		{
			inner = itemArray[0][0].slice();
			data = itemArray[0][1].slice();
		}
		//グリッド x軸　or θ軸
		else if(e.currentTarget.id == "cItem2_0")
		{
			if(document.getElementById("graphModeText").innerHTML == "θ")
			{
				//弧度法
				if(document.getElementById("methodText").innerHTML == "弧度法")
				{
					inner = itemArray[1][0].slice();
					data = itemArray[1][2].slice();
				}
				//度数法
				else
				{
					inner = itemArray[1][1].slice();
					data = itemArray[1][2].slice();
				}
			}
			else
			{
				inner = itemArray[0][0].slice();
				data = itemArray[0][1].slice();
			}
		}
		//グリッド y軸
		else if(e.currentTarget.id == "cItem2_1")
		{
			inner = itemArray[0][0].slice();
			data = itemArray[0][1].slice();
		}
		
		openSelectBalloon("selectBalloon_config", "configBalloon", e.currentTarget.id, inner, data, changeItemData);
	}
	catch(e)
	{
		alert("openConfigBalloonHandler:" + e.toString());
	}
}

function changeItemData(id, num)
{
	try
	{
		
		var f = false;
		
		//目盛　θ軸
		if(id == "cItem1_0")
		{
			configArray[1][0] = num;
			
			f = true;
		}
		//目盛 y軸
		else if(id == "cItem1_1")
		{
			configArray[1][1] = num;
			
			f = true;
		}
		//グリッド　θ軸
		else if(id == "cItem2_0")
		{
			configArray[2][0] = num;
		}
		//グリッド　y軸
		else if(id == "cItem2_1")
		{
			configArray[2][1] = num;
		}
		
		if((id == "cItem1_0" || id == "cItem2_0"))
		{
			var str = document.getElementById(id).innerHTML;
			if(str.indexOf("#000000"))
			{
				str = str.replace("#000000", "#007AC5");
				document.getElementById(id).innerHTML = str;
			}
		}
		
		//目盛
		if(f)
		{
			if(document.getElementById("graphModeText").innerHTML == "θ" && configArray[1][0] != null)
			{
				changeGraphScale(Math.PI/2 * configArray[1][0]/180, configArray[1][1]);
			}
			else
			{
				changeGraphScale(configArray[1][0], configArray[1][1]);
			}
			
			changeScaleText();
		}
		//グリッド
		else
		{
			if(document.getElementById("graphModeText").innerHTML == "θ" && configArray[2][0] != null)
			{
				changeGraphGrid(Math.PI/2 * configArray[2][0]/180, configArray[2][1]);
			}
			else
			{
				changeGraphGrid(configArray[2][0], configArray[2][1]);
			}
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("changeItemData:" + e.toString());
	}
}

function changeScaleText()
{
	try
	{
		//ｘ軸の目盛
		changeScaleTextParts(scaleText[0], configArray[1][0], true, 10);
		
		//y軸の目盛
		changeScaleTextParts(scaleText[1], configArray[1][1], false, 10);
		
	}
	catch(e)
	{
		alert("changeScaleText:" + e.toString());
	}
}

function changeScaleTextParts(tArray, config, f, n)
{
	try
	{
		var scale;
		var tSpan;
		var i;
		var gSize;
		var sSize;
		
		var j;
		
		var limitCheck;
		
		
		if(typeof(leftLimit) != "undefined")
		{
			limitCheck = true;
		}
		
		if(config != null)
		{
			//x軸
			if(f)
			{
				if(document.getElementById("graphModeText").innerHTML == "θ")
				{
					scale = config/360;
					tSpan = baseCycle * scale;
				}
				else
				{
					scale = config;
					tSpan = span * scale;
				}
			}
			//y軸
			else
			{
				scale = config;
				tSpan = span * scale;
			}
		}
		
		if(f)
		{
			gSize = cW;
			sSize = cH/2;
		}
		else
		{
			gSize = cH;
			sSize = cW/2;
		}
		
		//間隔が違う場合
		if(tArray[0] != config)
		{
			//非表示に切替
			if(config == null)
			{
				if(tArray[2].length > 0)
				{
					leng = tArray[2].length;
					
					for(var i=0; i<leng; i++)
					{
						tArray[2][i].visible = false;
					}
				}
			}
			//テキストを切替
			else
			{
				//前のテキストを削除
				if(tArray[2].length > 0)
				{
					leng = tArray[2].length;
					
					for(var i=0; i<leng; i++)
					{
						cs.removeChild(tArray[2][i]);
					}
					
					tArray[2] = [];
				}
				
				j = -1;
				
				//テキストを作成
				for(i = gSize/2-tSpan; i>0; i -= tSpan)
				{
					var str;
					
					if(f)
					{
						if(document.getElementById("graphModeText").innerHTML == "θ")
						{
							if(document.getElementById("methodText").innerHTML == "弧度法")
							{
								str = getPointDataString(j*config, 1);
							}
							else
							{
								str = getPointDataString(j*config, 2);
							}
						}
						else
						{
							str = (j * config).toString();
						}
					}
					else
					{
						str = (-j * config).toString();
					}
					
					j--;
					
					var t0 = new createjs.Container();
					changePointText(t0, str, n);
					
					if(f)
					{
						t0.x = i;
						t0.y = sSize + 10;
						
						if(limitCheck == true && t0.x < cW/2 - leftLimit)
						{
							t0.visible = false;
						}
					}
					else
					{
						t0.x = sSize + t0.getBounds().width/2+10;
						t0.y = i-t0.getBounds().height/2;
					}
					
					//背景・グリッドより前面に追加
					cs.addChildAt(t0, 2);
					tArray[2].push(t0);
				}
				
				j=1;
				
				for(i=gSize/2+tSpan; i<gSize; i+=tSpan)
				{
					var str;
					
					if(f)
					{
						if(document.getElementById("graphModeText").innerHTML == "θ")
						{
							if(document.getElementById("methodText").innerHTML == "弧度法")
							{
								str = getPointDataString(j*config, 1);
							}
							else
							{
								str = getPointDataString(j*config, 2);
							}
						}
						else
						{
							str = (j * config).toString();
						}
					}
					else
					{
						str = (-j * config).toString();
					}
					
					j++;
					
					var t1 = new createjs.Container();
					changePointText(t1, str, n);
					
					if(f)
					{
						t1.x = i;
						t1.y = sSize + 10;
						
						if(limitCheck && t1.x < cW/2-leftLimit)
						{
							t1.visible = false;
						}
					}
					else
					{
						t1.x = sSize + t1.getBounds().width/2+10;
						t1.y = i-t1.getBounds().height/2;
					}
					
					//背景・グリッドより前面に追加
					cs.addChildAt(t1, 2);
					tArray[2].push(t1);
				}
				
				if(document.getElementById('methodText') != null && document.getElementById('methodText').innerHTML == "弧度法")
				{
					scale[1] = true;	
				}
				else
				{
					scale[1] = false;
				}
				
				tArray[0] = config;
			}
		}
		//同じ場合
		else
		{
			//表示の法が同じ場合，テキストを表示
			if(
				document.getElementById("graphModeText").innerHTML == "x"
				||((tArray[1] == true && document.getElementById('methodText').innerHTML == "弧度法")||(tArray[1] == false && document.getElementById('methodText').innerHTML == "度数法")))
			{
				leng = tArray[2].length;

				for(var i=0; i<leng; i++)
				{
					if(!limitCheck || tArray[2][i].x >= cW/2-leftLimit)
					{
						tArray[2][i].visible = true;
					}
				}
			}
			//法が変わる場合，内部のテキストを変更
			else
			{
				leng = tArray[2].length;
				
				j= 1;
				
				for(var i=0; i<leng; i++)
				{
					var str;
					
					if(f)
					{
						if(document.getElementById("graphModeText").innerHTML == "θ")
						{
							if(document.getElementById("methodText").innerHTML == "弧度法")
							{
								str = getPointDataString(j*config, 1);
							}
							else
							{
								str = getPointDataString(j*config, 2);
							}
						}
						else
						{
							str = (j * config).toString();
						}
					}
					else
					{
						str = (-j * config).toString();
					}
					
					j++;
					
					if(i < leng/2)
					{
						if(f)
						{
							changePointText(tArray[2][i], "-"+str, n);
						}
						else
						{
							changePointText(tArray[2][i], str.substring(1, str.length), n);
						}
						
						if(i+1 >= leng/2)
						{
							j=1;
						}
					}
					else
					{
						changePointText(tArray[2][i], str, n);
					}
					
					if(!f || !limitCheck || tArray[2][i].x >= cW/2-leftLimit)
					{
						tArray[2][i].visible = true;
					}
				}
				
				
				if(document.getElementById('methodText') != null && document.getElementById('methodText').innerHTML == "弧度法")
				{
					tArray[1] = true;
				}
				else
				{
					tArray[1] = false;
				}
			}
		}
	}
	catch(e)
	{
		alert("changeScaleTextParts:" + e.toString());
	}
}


